/* ai.c generated by valac 0.43.92, the Vala compiler
 * generated from ai.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright © 2014 Nikhar Agrawal
 *
 * This file is part of Four-in-a-row.
 *
 * Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 *(at your option) any later version.
 *
 * Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Four-in-a-row.  If not, see <http://www.gnu.org/licenses/>. */
/* Here NEG_INF is supposed to be the lowest possible int value. int.MIN
MAX_HEURIST_VALUE is the maximum value that the heuristic functions can return.
It is returned when AI wins. -1*MAX_HEURIST_VALUE is returned when Human wins
MAX_HEURIST_VALUE < NEG_INF/plies */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	PLAYER_NONE,
	PLAYER_HUMAN,
	PLAYER_AI
} Player;

#define TYPE_PLAYER (player_get_type ())
typedef enum  {
	DIFFICULTY_EASY,
	DIFFICULTY_MEDIUM,
	DIFFICULTY_HARD
} Difficulty;

#define TYPE_DIFFICULTY (difficulty_get_type ())

#define TYPE_DECISION_TREE (decision_tree_get_type ())
#define DECISION_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DECISION_TREE, DecisionTree))
#define DECISION_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DECISION_TREE, DecisionTreeClass))
#define IS_DECISION_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DECISION_TREE))
#define IS_DECISION_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DECISION_TREE))
#define DECISION_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DECISION_TREE, DecisionTreeClass))

typedef struct _DecisionTree DecisionTree;
typedef struct _DecisionTreeClass DecisionTreeClass;
#define _decision_tree_unref0(var) ((var == NULL) ? NULL : (var = (decision_tree_unref (var), NULL)))
typedef struct _DecisionTreePrivate DecisionTreePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecDecisionTree ParamSpecDecisionTree;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DecisionTree {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DecisionTreePrivate * priv;
};

struct _DecisionTreeClass {
	GTypeClass parent_class;
	void (*finalize) (DecisionTree *self);
};

struct _DecisionTreePrivate {
	Player* board;
	gint board_length1;
	gint board_length2;
	gint plies;
	Player last_moving_player;
	gint next_move_in_column;
	Difficulty level;
};

struct _ParamSpecDecisionTree {
	GParamSpec parent_instance;
};

static gint DecisionTree_private_offset;
static gpointer decision_tree_parent_class = NULL;

#define NEG_INF -100000
#define MAX_HEURIST_VALUE 10000
#define BOARD_ROWS 6
#define BOARD_COLUMNS 7
GType player_get_type (void) G_GNUC_CONST;
GType difficulty_get_type (void) G_GNUC_CONST;
gint playgame (const gchar* moves_until_now);
gpointer decision_tree_ref (gpointer instance);
void decision_tree_unref (gpointer instance);
GParamSpec* param_spec_decision_tree (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_decision_tree (GValue* value,
                              gpointer v_object);
void value_take_decision_tree (GValue* value,
                               gpointer v_object);
gpointer value_get_decision_tree (const GValue* value);
GType decision_tree_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DecisionTree, decision_tree_unref)
DecisionTree* decision_tree_new (void);
DecisionTree* decision_tree_construct (GType object_type);
gint decision_tree_playgame (DecisionTree* self,
                             const gchar* vstr);
void decision_tree_print_board (DecisionTree* self);
static gint decision_tree_negamax (DecisionTree* self,
                            gint height,
                            gint alpha,
                            gint beta);
static gboolean decision_tree_board_full (DecisionTree* self);
static gint decision_tree_heurist (DecisionTree* self);
static gboolean decision_tree_move (DecisionTree* self,
                             gint column);
static gboolean decision_tree_victory (DecisionTree* self,
                                gint column);
static void decision_tree_unmove (DecisionTree* self,
                           gint column);
static gboolean decision_tree_vertical_win (DecisionTree* self,
                                     gint i,
                                     gint j);
static gboolean decision_tree_horizontal_win (DecisionTree* self,
                                       gint i,
                                       gint j);
static gboolean decision_tree_forward_diagonal_win (DecisionTree* self,
                                             gint i,
                                             gint j);
static gboolean decision_tree_backward_diagonal_win (DecisionTree* self,
                                              gint i,
                                              gint j);
void decision_tree_update_board (DecisionTree* self,
                                 const gchar* vstr);
static gint decision_tree_immediate_win (DecisionTree* self,
                                  Player p);
static void decision_tree_set_level (DecisionTree* self,
                              const gchar* vstr);
static gint decision_tree_heurist_easy (DecisionTree* self);
static gint decision_tree_heurist_medium (DecisionTree* self);
static gint decision_tree_heurist_hard (DecisionTree* self);
static gint decision_tree_count_3_in_a_row (DecisionTree* self,
                                     Player p);
static gboolean decision_tree_all_adjacent_empty (DecisionTree* self,
                                           gint i,
                                           gint j);
gint decision_tree_playandcheck (DecisionTree* self,
                                 const gchar* vstr);
static void decision_tree_finalize (DecisionTree * obj);

GType
player_get_type (void)
{
	static volatile gsize player_type_id__volatile = 0;
	if (g_once_init_enter (&player_type_id__volatile)) {
		static const GEnumValue values[] = {{PLAYER_NONE, "PLAYER_NONE", "none"}, {PLAYER_HUMAN, "PLAYER_HUMAN", "human"}, {PLAYER_AI, "PLAYER_AI", "ai"}, {0, NULL, NULL}};
		GType player_type_id;
		player_type_id = g_enum_register_static ("Player", values);
		g_once_init_leave (&player_type_id__volatile, player_type_id);
	}
	return player_type_id__volatile;
}

GType
difficulty_get_type (void)
{
	static volatile gsize difficulty_type_id__volatile = 0;
	if (g_once_init_enter (&difficulty_type_id__volatile)) {
		static const GEnumValue values[] = {{DIFFICULTY_EASY, "DIFFICULTY_EASY", "easy"}, {DIFFICULTY_MEDIUM, "DIFFICULTY_MEDIUM", "medium"}, {DIFFICULTY_HARD, "DIFFICULTY_HARD", "hard"}, {0, NULL, NULL}};
		GType difficulty_type_id;
		difficulty_type_id = g_enum_register_static ("Difficulty", values);
		g_once_init_leave (&difficulty_type_id__volatile, difficulty_type_id);
	}
	return difficulty_type_id__volatile;
}

gint
playgame (const gchar* moves_until_now)
{
	gint result = 0;
	DecisionTree* t = NULL;
	DecisionTree* _tmp0_;
#line 31 "../src/ai.vala"
	g_return_val_if_fail (moves_until_now != NULL, 0);
#line 33 "../src/ai.vala"
	_tmp0_ = decision_tree_new ();
#line 33 "../src/ai.vala"
	t = _tmp0_;
#line 34 "../src/ai.vala"
	result = decision_tree_playgame (t, moves_until_now);
#line 34 "../src/ai.vala"
	_decision_tree_unref0 (t);
#line 34 "../src/ai.vala"
	return result;
#line 208 "ai.c"
}

static inline gpointer
decision_tree_get_instance_private (DecisionTree* self)
{
	return G_STRUCT_MEMBER_P (self, DecisionTree_private_offset);
}

DecisionTree*
decision_tree_construct (GType object_type)
{
	DecisionTree* self = NULL;
#line 51 "../src/ai.vala"
	self = (DecisionTree*) g_type_create_instance (object_type);
#line 223 "ai.c"
	{
		gint i = 0;
#line 53 "../src/ai.vala"
		i = 0;
#line 228 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 53 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 53 "../src/ai.vala"
			while (TRUE) {
#line 53 "../src/ai.vala"
				if (!_tmp0_) {
#line 237 "ai.c"
					gint _tmp1_;
#line 53 "../src/ai.vala"
					_tmp1_ = i;
#line 53 "../src/ai.vala"
					i = _tmp1_ + 1;
#line 243 "ai.c"
				}
#line 53 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 53 "../src/ai.vala"
				if (!(i < BOARD_ROWS)) {
#line 53 "../src/ai.vala"
					break;
#line 251 "ai.c"
				}
				{
					gint j = 0;
#line 54 "../src/ai.vala"
					j = 0;
#line 257 "ai.c"
					{
						gboolean _tmp2_ = FALSE;
#line 54 "../src/ai.vala"
						_tmp2_ = TRUE;
#line 54 "../src/ai.vala"
						while (TRUE) {
#line 264 "ai.c"
							Player* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
#line 54 "../src/ai.vala"
							if (!_tmp2_) {
#line 270 "ai.c"
								gint _tmp3_;
#line 54 "../src/ai.vala"
								_tmp3_ = j;
#line 54 "../src/ai.vala"
								j = _tmp3_ + 1;
#line 276 "ai.c"
							}
#line 54 "../src/ai.vala"
							_tmp2_ = FALSE;
#line 54 "../src/ai.vala"
							if (!(j < BOARD_COLUMNS)) {
#line 54 "../src/ai.vala"
								break;
#line 284 "ai.c"
							}
#line 55 "../src/ai.vala"
							_tmp4_ = self->priv->board;
#line 55 "../src/ai.vala"
							_tmp4__length1 = self->priv->board_length1;
#line 55 "../src/ai.vala"
							_tmp4__length2 = self->priv->board_length2;
#line 55 "../src/ai.vala"
							_tmp4_[(i * _tmp4__length2) + j] = PLAYER_NONE;
#line 294 "ai.c"
						}
					}
				}
			}
		}
	}
#line 51 "../src/ai.vala"
	return self;
#line 303 "ai.c"
}

DecisionTree*
decision_tree_new (void)
{
#line 51 "../src/ai.vala"
	return decision_tree_construct (TYPE_DECISION_TREE);
#line 311 "ai.c"
}

void
decision_tree_print_board (DecisionTree* self)
{
	FILE* _tmp8_;
#line 59 "../src/ai.vala"
	g_return_if_fail (self != NULL);
#line 320 "ai.c"
	{
		gint i = 0;
#line 61 "../src/ai.vala"
		i = 0;
#line 325 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 61 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 61 "../src/ai.vala"
			while (TRUE) {
#line 332 "ai.c"
				FILE* _tmp7_;
#line 61 "../src/ai.vala"
				if (!_tmp0_) {
#line 336 "ai.c"
					gint _tmp1_;
#line 61 "../src/ai.vala"
					_tmp1_ = i;
#line 61 "../src/ai.vala"
					i = _tmp1_ + 1;
#line 342 "ai.c"
				}
#line 61 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 61 "../src/ai.vala"
				if (!(i < BOARD_ROWS)) {
#line 61 "../src/ai.vala"
					break;
#line 350 "ai.c"
				}
				{
					gint j = 0;
#line 63 "../src/ai.vala"
					j = 0;
#line 356 "ai.c"
					{
						gboolean _tmp2_ = FALSE;
#line 63 "../src/ai.vala"
						_tmp2_ = TRUE;
#line 63 "../src/ai.vala"
						while (TRUE) {
#line 363 "ai.c"
							FILE* _tmp4_;
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Player _tmp6_;
#line 63 "../src/ai.vala"
							if (!_tmp2_) {
#line 371 "ai.c"
								gint _tmp3_;
#line 63 "../src/ai.vala"
								_tmp3_ = j;
#line 63 "../src/ai.vala"
								j = _tmp3_ + 1;
#line 377 "ai.c"
							}
#line 63 "../src/ai.vala"
							_tmp2_ = FALSE;
#line 63 "../src/ai.vala"
							if (!(j < BOARD_COLUMNS)) {
#line 63 "../src/ai.vala"
								break;
#line 385 "ai.c"
							}
#line 64 "../src/ai.vala"
							_tmp4_ = stdout;
#line 64 "../src/ai.vala"
							_tmp5_ = self->priv->board;
#line 64 "../src/ai.vala"
							_tmp5__length1 = self->priv->board_length1;
#line 64 "../src/ai.vala"
							_tmp5__length2 = self->priv->board_length2;
#line 64 "../src/ai.vala"
							_tmp6_ = _tmp5_[(i * _tmp5__length2) + j];
#line 64 "../src/ai.vala"
							fprintf (_tmp4_, "%d\t", (gint) _tmp6_);
#line 399 "ai.c"
						}
					}
				}
#line 65 "../src/ai.vala"
				_tmp7_ = stdout;
#line 65 "../src/ai.vala"
				fprintf (_tmp7_, "\n");
#line 407 "ai.c"
			}
		}
	}
#line 67 "../src/ai.vala"
	_tmp8_ = stdout;
#line 67 "../src/ai.vala"
	fprintf (_tmp8_, "\n");
#line 415 "ai.c"
}

static gint
decision_tree_negamax (DecisionTree* self,
                       gint height,
                       gint alpha,
                       gint beta)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gint max = 0;
	gint next = 0;
#line 72 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "../src/ai.vala"
	if (height == 0) {
#line 75 "../src/ai.vala"
		_tmp0_ = TRUE;
#line 434 "ai.c"
	} else {
#line 75 "../src/ai.vala"
		_tmp0_ = decision_tree_board_full (self);
#line 438 "ai.c"
	}
#line 75 "../src/ai.vala"
	if (_tmp0_) {
#line 442 "ai.c"
		Player _tmp1_;
#line 77 "../src/ai.vala"
		_tmp1_ = self->priv->last_moving_player;
#line 77 "../src/ai.vala"
		if (_tmp1_ == PLAYER_HUMAN) {
#line 78 "../src/ai.vala"
			result = decision_tree_heurist (self);
#line 78 "../src/ai.vala"
			return result;
#line 452 "ai.c"
		} else {
			Player _tmp2_;
#line 79 "../src/ai.vala"
			_tmp2_ = self->priv->last_moving_player;
#line 79 "../src/ai.vala"
			if (_tmp2_ == PLAYER_AI) {
#line 80 "../src/ai.vala"
				result = -1 * decision_tree_heurist (self);
#line 80 "../src/ai.vala"
				return result;
#line 463 "ai.c"
			} else {
#line 82 "../src/ai.vala"
				result = 0;
#line 82 "../src/ai.vala"
				return result;
#line 469 "ai.c"
			}
		}
	}
#line 87 "../src/ai.vala"
	max = NEG_INF;
#line 91 "../src/ai.vala"
	next = -1;
#line 477 "ai.c"
	{
		gint column = 0;
#line 93 "../src/ai.vala"
		column = 0;
#line 482 "ai.c"
		{
			gboolean _tmp3_ = FALSE;
#line 93 "../src/ai.vala"
			_tmp3_ = TRUE;
#line 93 "../src/ai.vala"
			while (TRUE) {
#line 489 "ai.c"
				gint _tmp5_ = 0;
				gint temp = 0;
#line 93 "../src/ai.vala"
				if (!_tmp3_) {
#line 494 "ai.c"
					gint _tmp4_;
#line 93 "../src/ai.vala"
					_tmp4_ = column;
#line 93 "../src/ai.vala"
					column = _tmp4_ + 1;
#line 500 "ai.c"
				}
#line 93 "../src/ai.vala"
				_tmp3_ = FALSE;
#line 93 "../src/ai.vala"
				if (!(column < BOARD_COLUMNS)) {
#line 93 "../src/ai.vala"
					break;
#line 508 "ai.c"
				}
#line 96 "../src/ai.vala"
				if (!decision_tree_move (self, column)) {
#line 97 "../src/ai.vala"
					continue;
#line 514 "ai.c"
				}
#line 102 "../src/ai.vala"
				if (decision_tree_victory (self, column)) {
#line 102 "../src/ai.vala"
					_tmp5_ = MAX_HEURIST_VALUE * height;
#line 520 "ai.c"
				} else {
#line 102 "../src/ai.vala"
					_tmp5_ = -1 * decision_tree_negamax (self, height - 1, -1 * beta, -1 * alpha);
#line 524 "ai.c"
				}
#line 102 "../src/ai.vala"
				temp = _tmp5_;
#line 104 "../src/ai.vala"
				decision_tree_unmove (self, column);
#line 106 "../src/ai.vala"
				if (temp > max) {
#line 108 "../src/ai.vala"
					next = column;
#line 109 "../src/ai.vala"
					max = temp;
#line 536 "ai.c"
				}
#line 112 "../src/ai.vala"
				if (temp > alpha) {
#line 113 "../src/ai.vala"
					alpha = temp;
#line 542 "ai.c"
				}
#line 115 "../src/ai.vala"
				if (alpha >= beta) {
#line 116 "../src/ai.vala"
					break;
#line 548 "ai.c"
				}
			}
		}
	}
#line 120 "../src/ai.vala"
	if (height == self->priv->plies) {
#line 121 "../src/ai.vala"
		self->priv->next_move_in_column = next;
#line 557 "ai.c"
	}
#line 123 "../src/ai.vala"
	result = max;
#line 123 "../src/ai.vala"
	return result;
#line 563 "ai.c"
}

static gboolean
decision_tree_victory (DecisionTree* self,
                       gint column)
{
	gboolean result = FALSE;
	gint row = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 127 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 577 "ai.c"
	{
		gboolean _tmp0_ = FALSE;
#line 131 "../src/ai.vala"
		row = 0;
#line 131 "../src/ai.vala"
		_tmp0_ = TRUE;
#line 131 "../src/ai.vala"
		while (TRUE) {
#line 586 "ai.c"
			gboolean _tmp2_ = FALSE;
#line 131 "../src/ai.vala"
			if (!_tmp0_) {
#line 590 "ai.c"
				gint _tmp1_;
#line 131 "../src/ai.vala"
				_tmp1_ = row;
#line 131 "../src/ai.vala"
				row = _tmp1_ + 1;
#line 596 "ai.c"
			}
#line 131 "../src/ai.vala"
			_tmp0_ = FALSE;
#line 131 "../src/ai.vala"
			if (row < BOARD_ROWS) {
#line 602 "ai.c"
				Player* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				Player _tmp4_;
#line 131 "../src/ai.vala"
				_tmp3_ = self->priv->board;
#line 131 "../src/ai.vala"
				_tmp3__length1 = self->priv->board_length1;
#line 131 "../src/ai.vala"
				_tmp3__length2 = self->priv->board_length2;
#line 131 "../src/ai.vala"
				_tmp4_ = _tmp3_[(row * _tmp3__length2) + column];
#line 131 "../src/ai.vala"
				_tmp2_ = _tmp4_ == PLAYER_NONE;
#line 617 "ai.c"
			} else {
#line 131 "../src/ai.vala"
				_tmp2_ = FALSE;
#line 621 "ai.c"
			}
#line 131 "../src/ai.vala"
			if (!_tmp2_) {
#line 131 "../src/ai.vala"
				break;
#line 627 "ai.c"
			}
		}
	}
#line 133 "../src/ai.vala"
	if (decision_tree_vertical_win (self, row, column)) {
#line 133 "../src/ai.vala"
		_tmp7_ = TRUE;
#line 635 "ai.c"
	} else {
#line 134 "../src/ai.vala"
		_tmp7_ = decision_tree_horizontal_win (self, row, column);
#line 639 "ai.c"
	}
#line 133 "../src/ai.vala"
	if (_tmp7_) {
#line 133 "../src/ai.vala"
		_tmp6_ = TRUE;
#line 645 "ai.c"
	} else {
#line 135 "../src/ai.vala"
		_tmp6_ = decision_tree_forward_diagonal_win (self, row, column);
#line 649 "ai.c"
	}
#line 133 "../src/ai.vala"
	if (_tmp6_) {
#line 133 "../src/ai.vala"
		_tmp5_ = TRUE;
#line 655 "ai.c"
	} else {
#line 136 "../src/ai.vala"
		_tmp5_ = decision_tree_backward_diagonal_win (self, row, column);
#line 659 "ai.c"
	}
#line 133 "../src/ai.vala"
	result = _tmp5_;
#line 133 "../src/ai.vala"
	return result;
#line 665 "ai.c"
}

static gboolean
decision_tree_forward_diagonal_win (DecisionTree* self,
                                    gint i,
                                    gint j)
{
	gboolean result = FALSE;
	gint count = 0;
#line 139 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 141 "../src/ai.vala"
	count = 0;
#line 679 "ai.c"
	{
		gint k = 0;
		gint l = 0;
#line 143 "../src/ai.vala"
		k = i;
#line 143 "../src/ai.vala"
		l = j;
#line 687 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 143 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 143 "../src/ai.vala"
			while (TRUE) {
#line 694 "ai.c"
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
#line 143 "../src/ai.vala"
				if (!_tmp0_) {
#line 699 "ai.c"
					gint _tmp1_;
					gint _tmp2_;
					gint _tmp3_;
#line 143 "../src/ai.vala"
					_tmp1_ = k;
#line 143 "../src/ai.vala"
					k = _tmp1_ - 1;
#line 143 "../src/ai.vala"
					_tmp2_ = l;
#line 143 "../src/ai.vala"
					l = _tmp2_ + 1;
#line 143 "../src/ai.vala"
					_tmp3_ = count;
#line 143 "../src/ai.vala"
					count = _tmp3_ + 1;
#line 715 "ai.c"
				}
#line 143 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 143 "../src/ai.vala"
				if (k >= 0) {
#line 143 "../src/ai.vala"
					_tmp5_ = l < BOARD_COLUMNS;
#line 723 "ai.c"
				} else {
#line 143 "../src/ai.vala"
					_tmp5_ = FALSE;
#line 727 "ai.c"
				}
#line 143 "../src/ai.vala"
				if (_tmp5_) {
#line 731 "ai.c"
					Player* _tmp6_;
					gint _tmp6__length1;
					gint _tmp6__length2;
					Player _tmp7_;
					Player _tmp8_;
#line 143 "../src/ai.vala"
					_tmp6_ = self->priv->board;
#line 143 "../src/ai.vala"
					_tmp6__length1 = self->priv->board_length1;
#line 143 "../src/ai.vala"
					_tmp6__length2 = self->priv->board_length2;
#line 143 "../src/ai.vala"
					_tmp7_ = _tmp6_[(k * _tmp6__length2) + l];
#line 143 "../src/ai.vala"
					_tmp8_ = self->priv->last_moving_player;
#line 143 "../src/ai.vala"
					_tmp4_ = _tmp7_ == _tmp8_;
#line 749 "ai.c"
				} else {
#line 143 "../src/ai.vala"
					_tmp4_ = FALSE;
#line 753 "ai.c"
				}
#line 143 "../src/ai.vala"
				if (!_tmp4_) {
#line 143 "../src/ai.vala"
					break;
#line 759 "ai.c"
				}
			}
		}
	}
	{
		gint k = 0;
		gint l = 0;
#line 144 "../src/ai.vala"
		k = i + 1;
#line 144 "../src/ai.vala"
		l = j - 1;
#line 771 "ai.c"
		{
			gboolean _tmp9_ = FALSE;
#line 144 "../src/ai.vala"
			_tmp9_ = TRUE;
#line 144 "../src/ai.vala"
			while (TRUE) {
#line 778 "ai.c"
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
#line 144 "../src/ai.vala"
				if (!_tmp9_) {
#line 783 "ai.c"
					gint _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
#line 144 "../src/ai.vala"
					_tmp10_ = k;
#line 144 "../src/ai.vala"
					k = _tmp10_ + 1;
#line 144 "../src/ai.vala"
					_tmp11_ = l;
#line 144 "../src/ai.vala"
					l = _tmp11_ - 1;
#line 144 "../src/ai.vala"
					_tmp12_ = count;
#line 144 "../src/ai.vala"
					count = _tmp12_ + 1;
#line 799 "ai.c"
				}
#line 144 "../src/ai.vala"
				_tmp9_ = FALSE;
#line 144 "../src/ai.vala"
				if (k < BOARD_ROWS) {
#line 144 "../src/ai.vala"
					_tmp14_ = l >= 0;
#line 807 "ai.c"
				} else {
#line 144 "../src/ai.vala"
					_tmp14_ = FALSE;
#line 811 "ai.c"
				}
#line 144 "../src/ai.vala"
				if (_tmp14_) {
#line 815 "ai.c"
					Player* _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					Player _tmp16_;
					Player _tmp17_;
#line 144 "../src/ai.vala"
					_tmp15_ = self->priv->board;
#line 144 "../src/ai.vala"
					_tmp15__length1 = self->priv->board_length1;
#line 144 "../src/ai.vala"
					_tmp15__length2 = self->priv->board_length2;
#line 144 "../src/ai.vala"
					_tmp16_ = _tmp15_[(k * _tmp15__length2) + l];
#line 144 "../src/ai.vala"
					_tmp17_ = self->priv->last_moving_player;
#line 144 "../src/ai.vala"
					_tmp13_ = _tmp16_ == _tmp17_;
#line 833 "ai.c"
				} else {
#line 144 "../src/ai.vala"
					_tmp13_ = FALSE;
#line 837 "ai.c"
				}
#line 144 "../src/ai.vala"
				if (!_tmp13_) {
#line 144 "../src/ai.vala"
					break;
#line 843 "ai.c"
				}
			}
		}
	}
#line 146 "../src/ai.vala"
	result = count >= 4;
#line 146 "../src/ai.vala"
	return result;
#line 852 "ai.c"
}

static gboolean
decision_tree_backward_diagonal_win (DecisionTree* self,
                                     gint i,
                                     gint j)
{
	gboolean result = FALSE;
	gint count = 0;
#line 149 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "../src/ai.vala"
	count = 0;
#line 866 "ai.c"
	{
		gint k = 0;
		gint l = 0;
#line 153 "../src/ai.vala"
		k = i;
#line 153 "../src/ai.vala"
		l = j;
#line 874 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 153 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 153 "../src/ai.vala"
			while (TRUE) {
#line 881 "ai.c"
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
#line 153 "../src/ai.vala"
				if (!_tmp0_) {
#line 886 "ai.c"
					gint _tmp1_;
					gint _tmp2_;
					gint _tmp3_;
#line 153 "../src/ai.vala"
					_tmp1_ = k;
#line 153 "../src/ai.vala"
					k = _tmp1_ - 1;
#line 153 "../src/ai.vala"
					_tmp2_ = l;
#line 153 "../src/ai.vala"
					l = _tmp2_ - 1;
#line 153 "../src/ai.vala"
					_tmp3_ = count;
#line 153 "../src/ai.vala"
					count = _tmp3_ + 1;
#line 902 "ai.c"
				}
#line 153 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 153 "../src/ai.vala"
				if (k >= 0) {
#line 153 "../src/ai.vala"
					_tmp5_ = l >= 0;
#line 910 "ai.c"
				} else {
#line 153 "../src/ai.vala"
					_tmp5_ = FALSE;
#line 914 "ai.c"
				}
#line 153 "../src/ai.vala"
				if (_tmp5_) {
#line 918 "ai.c"
					Player* _tmp6_;
					gint _tmp6__length1;
					gint _tmp6__length2;
					Player _tmp7_;
					Player _tmp8_;
#line 153 "../src/ai.vala"
					_tmp6_ = self->priv->board;
#line 153 "../src/ai.vala"
					_tmp6__length1 = self->priv->board_length1;
#line 153 "../src/ai.vala"
					_tmp6__length2 = self->priv->board_length2;
#line 153 "../src/ai.vala"
					_tmp7_ = _tmp6_[(k * _tmp6__length2) + l];
#line 153 "../src/ai.vala"
					_tmp8_ = self->priv->last_moving_player;
#line 153 "../src/ai.vala"
					_tmp4_ = _tmp7_ == _tmp8_;
#line 936 "ai.c"
				} else {
#line 153 "../src/ai.vala"
					_tmp4_ = FALSE;
#line 940 "ai.c"
				}
#line 153 "../src/ai.vala"
				if (!_tmp4_) {
#line 153 "../src/ai.vala"
					break;
#line 946 "ai.c"
				}
			}
		}
	}
	{
		gint k = 0;
		gint l = 0;
#line 154 "../src/ai.vala"
		k = i + 1;
#line 154 "../src/ai.vala"
		l = j + 1;
#line 958 "ai.c"
		{
			gboolean _tmp9_ = FALSE;
#line 154 "../src/ai.vala"
			_tmp9_ = TRUE;
#line 154 "../src/ai.vala"
			while (TRUE) {
#line 965 "ai.c"
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
#line 154 "../src/ai.vala"
				if (!_tmp9_) {
#line 970 "ai.c"
					gint _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
#line 154 "../src/ai.vala"
					_tmp10_ = k;
#line 154 "../src/ai.vala"
					k = _tmp10_ + 1;
#line 154 "../src/ai.vala"
					_tmp11_ = l;
#line 154 "../src/ai.vala"
					l = _tmp11_ + 1;
#line 154 "../src/ai.vala"
					_tmp12_ = count;
#line 154 "../src/ai.vala"
					count = _tmp12_ + 1;
#line 986 "ai.c"
				}
#line 154 "../src/ai.vala"
				_tmp9_ = FALSE;
#line 154 "../src/ai.vala"
				if (k < BOARD_ROWS) {
#line 154 "../src/ai.vala"
					_tmp14_ = l < BOARD_COLUMNS;
#line 994 "ai.c"
				} else {
#line 154 "../src/ai.vala"
					_tmp14_ = FALSE;
#line 998 "ai.c"
				}
#line 154 "../src/ai.vala"
				if (_tmp14_) {
#line 1002 "ai.c"
					Player* _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					Player _tmp16_;
					Player _tmp17_;
#line 154 "../src/ai.vala"
					_tmp15_ = self->priv->board;
#line 154 "../src/ai.vala"
					_tmp15__length1 = self->priv->board_length1;
#line 154 "../src/ai.vala"
					_tmp15__length2 = self->priv->board_length2;
#line 154 "../src/ai.vala"
					_tmp16_ = _tmp15_[(k * _tmp15__length2) + l];
#line 154 "../src/ai.vala"
					_tmp17_ = self->priv->last_moving_player;
#line 154 "../src/ai.vala"
					_tmp13_ = _tmp16_ == _tmp17_;
#line 1020 "ai.c"
				} else {
#line 154 "../src/ai.vala"
					_tmp13_ = FALSE;
#line 1024 "ai.c"
				}
#line 154 "../src/ai.vala"
				if (!_tmp13_) {
#line 154 "../src/ai.vala"
					break;
#line 1030 "ai.c"
				}
			}
		}
	}
#line 156 "../src/ai.vala"
	result = count >= 4;
#line 156 "../src/ai.vala"
	return result;
#line 1039 "ai.c"
}

static gboolean
decision_tree_horizontal_win (DecisionTree* self,
                              gint i,
                              gint j)
{
	gboolean result = FALSE;
	gint count = 0;
#line 159 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "../src/ai.vala"
	count = 0;
#line 1053 "ai.c"
	{
		gint k = 0;
#line 163 "../src/ai.vala"
		k = j;
#line 1058 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 163 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 163 "../src/ai.vala"
			while (TRUE) {
#line 1065 "ai.c"
				gboolean _tmp3_ = FALSE;
#line 163 "../src/ai.vala"
				if (!_tmp0_) {
#line 1069 "ai.c"
					gint _tmp1_;
					gint _tmp2_;
#line 163 "../src/ai.vala"
					_tmp1_ = k;
#line 163 "../src/ai.vala"
					k = _tmp1_ - 1;
#line 163 "../src/ai.vala"
					_tmp2_ = count;
#line 163 "../src/ai.vala"
					count = _tmp2_ + 1;
#line 1080 "ai.c"
				}
#line 163 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 163 "../src/ai.vala"
				if (k >= 0) {
#line 1086 "ai.c"
					Player* _tmp4_;
					gint _tmp4__length1;
					gint _tmp4__length2;
					Player _tmp5_;
					Player _tmp6_;
#line 163 "../src/ai.vala"
					_tmp4_ = self->priv->board;
#line 163 "../src/ai.vala"
					_tmp4__length1 = self->priv->board_length1;
#line 163 "../src/ai.vala"
					_tmp4__length2 = self->priv->board_length2;
#line 163 "../src/ai.vala"
					_tmp5_ = _tmp4_[(i * _tmp4__length2) + k];
#line 163 "../src/ai.vala"
					_tmp6_ = self->priv->last_moving_player;
#line 163 "../src/ai.vala"
					_tmp3_ = _tmp5_ == _tmp6_;
#line 1104 "ai.c"
				} else {
#line 163 "../src/ai.vala"
					_tmp3_ = FALSE;
#line 1108 "ai.c"
				}
#line 163 "../src/ai.vala"
				if (!_tmp3_) {
#line 163 "../src/ai.vala"
					break;
#line 1114 "ai.c"
				}
			}
		}
	}
	{
		gint k = 0;
#line 164 "../src/ai.vala"
		k = j + 1;
#line 1123 "ai.c"
		{
			gboolean _tmp7_ = FALSE;
#line 164 "../src/ai.vala"
			_tmp7_ = TRUE;
#line 164 "../src/ai.vala"
			while (TRUE) {
#line 1130 "ai.c"
				gboolean _tmp10_ = FALSE;
#line 164 "../src/ai.vala"
				if (!_tmp7_) {
#line 1134 "ai.c"
					gint _tmp8_;
					gint _tmp9_;
#line 164 "../src/ai.vala"
					_tmp8_ = k;
#line 164 "../src/ai.vala"
					k = _tmp8_ + 1;
#line 164 "../src/ai.vala"
					_tmp9_ = count;
#line 164 "../src/ai.vala"
					count = _tmp9_ + 1;
#line 1145 "ai.c"
				}
#line 164 "../src/ai.vala"
				_tmp7_ = FALSE;
#line 164 "../src/ai.vala"
				if (k < BOARD_COLUMNS) {
#line 1151 "ai.c"
					Player* _tmp11_;
					gint _tmp11__length1;
					gint _tmp11__length2;
					Player _tmp12_;
					Player _tmp13_;
#line 164 "../src/ai.vala"
					_tmp11_ = self->priv->board;
#line 164 "../src/ai.vala"
					_tmp11__length1 = self->priv->board_length1;
#line 164 "../src/ai.vala"
					_tmp11__length2 = self->priv->board_length2;
#line 164 "../src/ai.vala"
					_tmp12_ = _tmp11_[(i * _tmp11__length2) + k];
#line 164 "../src/ai.vala"
					_tmp13_ = self->priv->last_moving_player;
#line 164 "../src/ai.vala"
					_tmp10_ = _tmp12_ == _tmp13_;
#line 1169 "ai.c"
				} else {
#line 164 "../src/ai.vala"
					_tmp10_ = FALSE;
#line 1173 "ai.c"
				}
#line 164 "../src/ai.vala"
				if (!_tmp10_) {
#line 164 "../src/ai.vala"
					break;
#line 1179 "ai.c"
				}
			}
		}
	}
#line 166 "../src/ai.vala"
	result = count >= 4;
#line 166 "../src/ai.vala"
	return result;
#line 1188 "ai.c"
}

static gboolean
decision_tree_vertical_win (DecisionTree* self,
                            gint i,
                            gint j)
{
	gboolean result = FALSE;
	gint count = 0;
#line 169 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/ai.vala"
	count = 0;
#line 1202 "ai.c"
	{
		gint k = 0;
#line 173 "../src/ai.vala"
		k = i;
#line 1207 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 173 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 173 "../src/ai.vala"
			while (TRUE) {
#line 1214 "ai.c"
				gboolean _tmp3_ = FALSE;
#line 173 "../src/ai.vala"
				if (!_tmp0_) {
#line 1218 "ai.c"
					gint _tmp1_;
					gint _tmp2_;
#line 173 "../src/ai.vala"
					_tmp1_ = k;
#line 173 "../src/ai.vala"
					k = _tmp1_ + 1;
#line 173 "../src/ai.vala"
					_tmp2_ = count;
#line 173 "../src/ai.vala"
					count = _tmp2_ + 1;
#line 1229 "ai.c"
				}
#line 173 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 173 "../src/ai.vala"
				if (k < BOARD_ROWS) {
#line 1235 "ai.c"
					Player* _tmp4_;
					gint _tmp4__length1;
					gint _tmp4__length2;
					Player _tmp5_;
					Player _tmp6_;
#line 173 "../src/ai.vala"
					_tmp4_ = self->priv->board;
#line 173 "../src/ai.vala"
					_tmp4__length1 = self->priv->board_length1;
#line 173 "../src/ai.vala"
					_tmp4__length2 = self->priv->board_length2;
#line 173 "../src/ai.vala"
					_tmp5_ = _tmp4_[(k * _tmp4__length2) + j];
#line 173 "../src/ai.vala"
					_tmp6_ = self->priv->last_moving_player;
#line 173 "../src/ai.vala"
					_tmp3_ = _tmp5_ == _tmp6_;
#line 1253 "ai.c"
				} else {
#line 173 "../src/ai.vala"
					_tmp3_ = FALSE;
#line 1257 "ai.c"
				}
#line 173 "../src/ai.vala"
				if (!_tmp3_) {
#line 173 "../src/ai.vala"
					break;
#line 1263 "ai.c"
				}
			}
		}
	}
#line 175 "../src/ai.vala"
	result = count >= 4;
#line 175 "../src/ai.vala"
	return result;
#line 1272 "ai.c"
}

static gboolean
decision_tree_board_full (DecisionTree* self)
{
	gboolean result = FALSE;
#line 179 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1281 "ai.c"
	{
		gint i = 0;
#line 181 "../src/ai.vala"
		i = 0;
#line 1286 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 181 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 181 "../src/ai.vala"
			while (TRUE) {
#line 1293 "ai.c"
				Player* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				Player _tmp3_;
#line 181 "../src/ai.vala"
				if (!_tmp0_) {
#line 1300 "ai.c"
					gint _tmp1_;
#line 181 "../src/ai.vala"
					_tmp1_ = i;
#line 181 "../src/ai.vala"
					i = _tmp1_ + 1;
#line 1306 "ai.c"
				}
#line 181 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 181 "../src/ai.vala"
				if (!(i < BOARD_COLUMNS)) {
#line 181 "../src/ai.vala"
					break;
#line 1314 "ai.c"
				}
#line 182 "../src/ai.vala"
				_tmp2_ = self->priv->board;
#line 182 "../src/ai.vala"
				_tmp2__length1 = self->priv->board_length1;
#line 182 "../src/ai.vala"
				_tmp2__length2 = self->priv->board_length2;
#line 182 "../src/ai.vala"
				_tmp3_ = _tmp2_[(0 * _tmp2__length2) + i];
#line 182 "../src/ai.vala"
				if (_tmp3_ == PLAYER_NONE) {
#line 183 "../src/ai.vala"
					result = FALSE;
#line 183 "../src/ai.vala"
					return result;
#line 1330 "ai.c"
				}
			}
		}
	}
#line 184 "../src/ai.vala"
	result = TRUE;
#line 184 "../src/ai.vala"
	return result;
#line 1339 "ai.c"
}

static gboolean
decision_tree_move (DecisionTree* self,
                    gint column)
{
	gboolean result = FALSE;
	gint row = 0;
	Player _tmp5_ = 0;
	Player _tmp6_;
	Player player = 0;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player _tmp8_;
	Player _tmp9_;
#line 188 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1358 "ai.c"
	{
		gboolean _tmp0_ = FALSE;
#line 192 "../src/ai.vala"
		row = BOARD_ROWS - 1;
#line 192 "../src/ai.vala"
		_tmp0_ = TRUE;
#line 192 "../src/ai.vala"
		while (TRUE) {
#line 1367 "ai.c"
			gboolean _tmp2_ = FALSE;
#line 192 "../src/ai.vala"
			if (!_tmp0_) {
#line 1371 "ai.c"
				gint _tmp1_;
#line 192 "../src/ai.vala"
				_tmp1_ = row;
#line 192 "../src/ai.vala"
				row = _tmp1_ - 1;
#line 1377 "ai.c"
			}
#line 192 "../src/ai.vala"
			_tmp0_ = FALSE;
#line 192 "../src/ai.vala"
			if (row >= 0) {
#line 1383 "ai.c"
				Player* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				Player _tmp4_;
#line 192 "../src/ai.vala"
				_tmp3_ = self->priv->board;
#line 192 "../src/ai.vala"
				_tmp3__length1 = self->priv->board_length1;
#line 192 "../src/ai.vala"
				_tmp3__length2 = self->priv->board_length2;
#line 192 "../src/ai.vala"
				_tmp4_ = _tmp3_[(row * _tmp3__length2) + column];
#line 192 "../src/ai.vala"
				_tmp2_ = _tmp4_ != PLAYER_NONE;
#line 1398 "ai.c"
			} else {
#line 192 "../src/ai.vala"
				_tmp2_ = FALSE;
#line 1402 "ai.c"
			}
#line 192 "../src/ai.vala"
			if (!_tmp2_) {
#line 192 "../src/ai.vala"
				break;
#line 1408 "ai.c"
			}
		}
	}
#line 194 "../src/ai.vala"
	if (row < 0) {
#line 195 "../src/ai.vala"
		result = FALSE;
#line 195 "../src/ai.vala"
		return result;
#line 1418 "ai.c"
	}
#line 198 "../src/ai.vala"
	_tmp6_ = self->priv->last_moving_player;
#line 198 "../src/ai.vala"
	if (_tmp6_ != PLAYER_AI) {
#line 198 "../src/ai.vala"
		_tmp5_ = PLAYER_AI;
#line 1426 "ai.c"
	} else {
#line 198 "../src/ai.vala"
		_tmp5_ = PLAYER_HUMAN;
#line 1430 "ai.c"
	}
#line 198 "../src/ai.vala"
	player = _tmp5_;
#line 199 "../src/ai.vala"
	_tmp7_ = self->priv->board;
#line 199 "../src/ai.vala"
	_tmp7__length1 = self->priv->board_length1;
#line 199 "../src/ai.vala"
	_tmp7__length2 = self->priv->board_length2;
#line 199 "../src/ai.vala"
	_tmp8_ = player;
#line 199 "../src/ai.vala"
	_tmp7_[(row * _tmp7__length2) + column] = _tmp8_;
#line 200 "../src/ai.vala"
	_tmp9_ = player;
#line 200 "../src/ai.vala"
	self->priv->last_moving_player = _tmp9_;
#line 202 "../src/ai.vala"
	result = TRUE;
#line 202 "../src/ai.vala"
	return result;
#line 1452 "ai.c"
}

static void
decision_tree_unmove (DecisionTree* self,
                      gint column)
{
	Player _tmp0_;
	gint row = 0;
	Player* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	Player _tmp7_ = 0;
	Player _tmp8_;
#line 206 "../src/ai.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/ai.vala"
	_tmp0_ = self->priv->last_moving_player;
#line 206 "../src/ai.vala"
	_vala_return_if_fail (_tmp0_ != PLAYER_NONE, "last_moving_player != Player.NONE");
#line 1472 "ai.c"
	{
		gboolean _tmp1_ = FALSE;
#line 211 "../src/ai.vala"
		row = 0;
#line 211 "../src/ai.vala"
		_tmp1_ = TRUE;
#line 211 "../src/ai.vala"
		while (TRUE) {
#line 1481 "ai.c"
			gboolean _tmp3_ = FALSE;
#line 211 "../src/ai.vala"
			if (!_tmp1_) {
#line 1485 "ai.c"
				gint _tmp2_;
#line 211 "../src/ai.vala"
				_tmp2_ = row;
#line 211 "../src/ai.vala"
				row = _tmp2_ + 1;
#line 1491 "ai.c"
			}
#line 211 "../src/ai.vala"
			_tmp1_ = FALSE;
#line 211 "../src/ai.vala"
			if (row < BOARD_ROWS) {
#line 1497 "ai.c"
				Player* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				Player _tmp5_;
#line 211 "../src/ai.vala"
				_tmp4_ = self->priv->board;
#line 211 "../src/ai.vala"
				_tmp4__length1 = self->priv->board_length1;
#line 211 "../src/ai.vala"
				_tmp4__length2 = self->priv->board_length2;
#line 211 "../src/ai.vala"
				_tmp5_ = _tmp4_[(row * _tmp4__length2) + column];
#line 211 "../src/ai.vala"
				_tmp3_ = _tmp5_ == PLAYER_NONE;
#line 1512 "ai.c"
			} else {
#line 211 "../src/ai.vala"
				_tmp3_ = FALSE;
#line 1516 "ai.c"
			}
#line 211 "../src/ai.vala"
			if (!_tmp3_) {
#line 211 "../src/ai.vala"
				break;
#line 1522 "ai.c"
			}
		}
	}
#line 213 "../src/ai.vala"
	_tmp6_ = self->priv->board;
#line 213 "../src/ai.vala"
	_tmp6__length1 = self->priv->board_length1;
#line 213 "../src/ai.vala"
	_tmp6__length2 = self->priv->board_length2;
#line 213 "../src/ai.vala"
	_tmp6_[(row * _tmp6__length2) + column] = PLAYER_NONE;
#line 215 "../src/ai.vala"
	_tmp8_ = self->priv->last_moving_player;
#line 215 "../src/ai.vala"
	if (_tmp8_ == PLAYER_AI) {
#line 215 "../src/ai.vala"
		_tmp7_ = PLAYER_HUMAN;
#line 1540 "ai.c"
	} else {
#line 215 "../src/ai.vala"
		_tmp7_ = PLAYER_AI;
#line 1544 "ai.c"
	}
#line 215 "../src/ai.vala"
	self->priv->last_moving_player = _tmp7_;
#line 1548 "ai.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 1565 "ai.c"
}

void
decision_tree_update_board (DecisionTree* self,
                            const gchar* vstr)
{
	gint _tmp0_;
	gint _tmp1_;
	Player _tmp2_ = 0;
	gint _tmp3_;
	gint _tmp4_;
	Player move = 0;
#line 219 "../src/ai.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/ai.vala"
	g_return_if_fail (vstr != NULL);
#line 221 "../src/ai.vala"
	self->priv->next_move_in_column = -1;
#line 224 "../src/ai.vala"
	_tmp0_ = strlen (vstr);
#line 224 "../src/ai.vala"
	_tmp1_ = _tmp0_;
#line 224 "../src/ai.vala"
	if (_tmp1_ == 2) {
#line 224 "../src/ai.vala"
		return;
#line 1592 "ai.c"
	}
#line 226 "../src/ai.vala"
	_tmp3_ = strlen (vstr);
#line 226 "../src/ai.vala"
	_tmp4_ = _tmp3_;
#line 226 "../src/ai.vala"
	if ((_tmp4_ % 2) == 0) {
#line 226 "../src/ai.vala"
		_tmp2_ = PLAYER_AI;
#line 1602 "ai.c"
	} else {
#line 226 "../src/ai.vala"
		_tmp2_ = PLAYER_HUMAN;
#line 1606 "ai.c"
	}
#line 226 "../src/ai.vala"
	move = _tmp2_;
#line 1610 "ai.c"
	{
		gint i = 0;
#line 228 "../src/ai.vala"
		i = 1;
#line 1615 "ai.c"
		{
			gboolean _tmp5_ = FALSE;
#line 228 "../src/ai.vala"
			_tmp5_ = TRUE;
#line 228 "../src/ai.vala"
			while (TRUE) {
#line 1622 "ai.c"
				gint _tmp7_;
				gint _tmp8_;
				gint column = 0;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint row = 0;
				Player* _tmp17_;
				gint _tmp17__length1;
				gint _tmp17__length2;
				Player _tmp18_;
				Player _tmp19_ = 0;
				Player _tmp20_;
#line 228 "../src/ai.vala"
				if (!_tmp5_) {
#line 1638 "ai.c"
					gint _tmp6_;
#line 228 "../src/ai.vala"
					_tmp6_ = i;
#line 228 "../src/ai.vala"
					i = _tmp6_ + 1;
#line 1644 "ai.c"
				}
#line 228 "../src/ai.vala"
				_tmp5_ = FALSE;
#line 228 "../src/ai.vala"
				_tmp7_ = strlen (vstr);
#line 228 "../src/ai.vala"
				_tmp8_ = _tmp7_;
#line 228 "../src/ai.vala"
				if (!(i < (_tmp8_ - 1))) {
#line 228 "../src/ai.vala"
					break;
#line 1656 "ai.c"
				}
#line 230 "../src/ai.vala"
				_tmp9_ = g_strdup_printf ("%c", string_get (vstr, (glong) i));
#line 230 "../src/ai.vala"
				_tmp10_ = _tmp9_;
#line 230 "../src/ai.vala"
				_tmp11_ = atoi (_tmp10_) - 1;
#line 230 "../src/ai.vala"
				_g_free0 (_tmp10_);
#line 230 "../src/ai.vala"
				column = _tmp11_;
#line 1668 "ai.c"
				{
					gboolean _tmp12_ = FALSE;
#line 234 "../src/ai.vala"
					row = BOARD_ROWS - 1;
#line 234 "../src/ai.vala"
					_tmp12_ = TRUE;
#line 234 "../src/ai.vala"
					while (TRUE) {
#line 1677 "ai.c"
						gboolean _tmp14_ = FALSE;
#line 234 "../src/ai.vala"
						if (!_tmp12_) {
#line 1681 "ai.c"
							gint _tmp13_;
#line 234 "../src/ai.vala"
							_tmp13_ = row;
#line 234 "../src/ai.vala"
							row = _tmp13_ - 1;
#line 1687 "ai.c"
						}
#line 234 "../src/ai.vala"
						_tmp12_ = FALSE;
#line 234 "../src/ai.vala"
						if (row >= 0) {
#line 1693 "ai.c"
							Player* _tmp15_;
							gint _tmp15__length1;
							gint _tmp15__length2;
							Player _tmp16_;
#line 234 "../src/ai.vala"
							_tmp15_ = self->priv->board;
#line 234 "../src/ai.vala"
							_tmp15__length1 = self->priv->board_length1;
#line 234 "../src/ai.vala"
							_tmp15__length2 = self->priv->board_length2;
#line 234 "../src/ai.vala"
							_tmp16_ = _tmp15_[(row * _tmp15__length2) + column];
#line 234 "../src/ai.vala"
							_tmp14_ = _tmp16_ != PLAYER_NONE;
#line 1708 "ai.c"
						} else {
#line 234 "../src/ai.vala"
							_tmp14_ = FALSE;
#line 1712 "ai.c"
						}
#line 234 "../src/ai.vala"
						if (!_tmp14_) {
#line 234 "../src/ai.vala"
							break;
#line 1718 "ai.c"
						}
					}
				}
#line 236 "../src/ai.vala"
				_tmp17_ = self->priv->board;
#line 236 "../src/ai.vala"
				_tmp17__length1 = self->priv->board_length1;
#line 236 "../src/ai.vala"
				_tmp17__length2 = self->priv->board_length2;
#line 236 "../src/ai.vala"
				_tmp18_ = move;
#line 236 "../src/ai.vala"
				_tmp17_[(row * _tmp17__length2) + column] = _tmp18_;
#line 238 "../src/ai.vala"
				_tmp20_ = move;
#line 238 "../src/ai.vala"
				if (_tmp20_ == PLAYER_HUMAN) {
#line 238 "../src/ai.vala"
					_tmp19_ = PLAYER_AI;
#line 1738 "ai.c"
				} else {
#line 238 "../src/ai.vala"
					_tmp19_ = PLAYER_HUMAN;
#line 1742 "ai.c"
				}
#line 238 "../src/ai.vala"
				move = _tmp19_;
#line 1746 "ai.c"
			}
		}
	}
#line 241 "../src/ai.vala"
	self->priv->last_moving_player = PLAYER_HUMAN;
#line 1752 "ai.c"
}

static gint
decision_tree_immediate_win (DecisionTree* self,
                             Player p)
{
	gint result = 0;
	Player old_last_moving_player = 0;
	Player _tmp0_;
	Player _tmp1_ = 0;
	gboolean player_wins = FALSE;
	gint i = 0;
	Player _tmp4_;
	gint _tmp5_ = 0;
#line 246 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 248 "../src/ai.vala"
	_tmp0_ = self->priv->last_moving_player;
#line 248 "../src/ai.vala"
	old_last_moving_player = _tmp0_;
#line 250 "../src/ai.vala"
	if (p == PLAYER_AI) {
#line 250 "../src/ai.vala"
		_tmp1_ = PLAYER_HUMAN;
#line 1777 "ai.c"
	} else {
#line 250 "../src/ai.vala"
		_tmp1_ = PLAYER_AI;
#line 1781 "ai.c"
	}
#line 250 "../src/ai.vala"
	self->priv->last_moving_player = _tmp1_;
#line 252 "../src/ai.vala"
	player_wins = FALSE;
#line 1787 "ai.c"
	{
		gboolean _tmp2_ = FALSE;
#line 254 "../src/ai.vala"
		i = 0;
#line 254 "../src/ai.vala"
		_tmp2_ = TRUE;
#line 254 "../src/ai.vala"
		while (TRUE) {
#line 254 "../src/ai.vala"
			if (!_tmp2_) {
#line 1798 "ai.c"
				gint _tmp3_;
#line 254 "../src/ai.vala"
				_tmp3_ = i;
#line 254 "../src/ai.vala"
				i = _tmp3_ + 1;
#line 1804 "ai.c"
			}
#line 254 "../src/ai.vala"
			_tmp2_ = FALSE;
#line 254 "../src/ai.vala"
			if (!(i < BOARD_COLUMNS)) {
#line 254 "../src/ai.vala"
				break;
#line 1812 "ai.c"
			}
#line 256 "../src/ai.vala"
			if (!decision_tree_move (self, i)) {
#line 257 "../src/ai.vala"
				continue;
#line 1818 "ai.c"
			}
#line 259 "../src/ai.vala"
			player_wins = decision_tree_victory (self, i);
#line 260 "../src/ai.vala"
			decision_tree_unmove (self, i);
#line 262 "../src/ai.vala"
			if (player_wins) {
#line 263 "../src/ai.vala"
				break;
#line 1828 "ai.c"
			}
		}
	}
#line 266 "../src/ai.vala"
	_tmp4_ = old_last_moving_player;
#line 266 "../src/ai.vala"
	self->priv->last_moving_player = _tmp4_;
#line 269 "../src/ai.vala"
	if (player_wins) {
#line 269 "../src/ai.vala"
		_tmp5_ = i;
#line 1840 "ai.c"
	} else {
#line 269 "../src/ai.vala"
		_tmp5_ = -1;
#line 1844 "ai.c"
	}
#line 269 "../src/ai.vala"
	result = _tmp5_;
#line 269 "../src/ai.vala"
	return result;
#line 1850 "ai.c"
}

gint
decision_tree_playgame (DecisionTree* self,
                        const gchar* vstr)
{
	gint result = 0;
	gint temp = 0;
#line 273 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 273 "../src/ai.vala"
	g_return_val_if_fail (vstr != NULL, 0);
#line 276 "../src/ai.vala"
	decision_tree_set_level (self, vstr);
#line 279 "../src/ai.vala"
	decision_tree_update_board (self, vstr);
#line 283 "../src/ai.vala"
	temp = decision_tree_immediate_win (self, PLAYER_AI);
#line 284 "../src/ai.vala"
	if (temp != -1) {
#line 285 "../src/ai.vala"
		result = temp + 1;
#line 285 "../src/ai.vala"
		return result;
#line 1875 "ai.c"
	}
#line 289 "../src/ai.vala"
	temp = decision_tree_immediate_win (self, PLAYER_HUMAN);
#line 290 "../src/ai.vala"
	if (temp != -1) {
#line 291 "../src/ai.vala"
		result = temp + 1;
#line 291 "../src/ai.vala"
		return result;
#line 1885 "ai.c"
	}
#line 294 "../src/ai.vala"
	decision_tree_negamax (self, self->priv->plies, NEG_INF, -1 * NEG_INF);
#line 297 "../src/ai.vala"
	result = self->priv->next_move_in_column + 1;
#line 297 "../src/ai.vala"
	return result;
#line 1893 "ai.c"
}

static gint
decision_tree_heurist (DecisionTree* self)
{
	gint result = 0;
	Difficulty _tmp0_;
#line 301 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 303 "../src/ai.vala"
	_tmp0_ = self->priv->level;
#line 303 "../src/ai.vala"
	if (_tmp0_ == DIFFICULTY_EASY) {
#line 304 "../src/ai.vala"
		result = decision_tree_heurist_easy (self);
#line 304 "../src/ai.vala"
		return result;
#line 1911 "ai.c"
	} else {
		Difficulty _tmp1_;
#line 305 "../src/ai.vala"
		_tmp1_ = self->priv->level;
#line 305 "../src/ai.vala"
		if (_tmp1_ == DIFFICULTY_MEDIUM) {
#line 306 "../src/ai.vala"
			result = decision_tree_heurist_medium (self);
#line 306 "../src/ai.vala"
			return result;
#line 1922 "ai.c"
		} else {
#line 308 "../src/ai.vala"
			result = decision_tree_heurist_hard (self);
#line 308 "../src/ai.vala"
			return result;
#line 1928 "ai.c"
		}
	}
}

static gint
decision_tree_heurist_easy (DecisionTree* self)
{
	gint result = 0;
#line 311 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 313 "../src/ai.vala"
	result = -1 * decision_tree_heurist_hard (self);
#line 313 "../src/ai.vala"
	return result;
#line 1943 "ai.c"
}

static gint
decision_tree_heurist_medium (DecisionTree* self)
{
	gint result = 0;
#line 316 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 318 "../src/ai.vala"
	result = (gint) g_random_int_range ((gint32) 1, (gint32) 49);
#line 318 "../src/ai.vala"
	return result;
#line 1956 "ai.c"
}

static gint
decision_tree_heurist_hard (DecisionTree* self)
{
	gint result = 0;
	gint count = 0;
	gint32 _tmp0_ = 0;
#line 321 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 323 "../src/ai.vala"
	count = decision_tree_count_3_in_a_row (self, PLAYER_AI) - decision_tree_count_3_in_a_row (self, PLAYER_HUMAN);
#line 324 "../src/ai.vala"
	if (count == 0) {
#line 324 "../src/ai.vala"
		_tmp0_ = g_random_int_range ((gint32) 1, (gint32) 49);
#line 1973 "ai.c"
	} else {
#line 324 "../src/ai.vala"
		_tmp0_ = (gint32) (count * 100);
#line 1977 "ai.c"
	}
#line 324 "../src/ai.vala"
	result = (gint) _tmp0_;
#line 324 "../src/ai.vala"
	return result;
#line 1983 "ai.c"
}

static gint
decision_tree_count_3_in_a_row (DecisionTree* self,
                                Player p)
{
	gint result = 0;
	gint count = 0;
	Player old_last_moving_player = 0;
	Player _tmp0_;
	Player _tmp10_;
#line 329 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 331 "../src/ai.vala"
	count = 0;
#line 333 "../src/ai.vala"
	_tmp0_ = self->priv->last_moving_player;
#line 333 "../src/ai.vala"
	old_last_moving_player = _tmp0_;
#line 335 "../src/ai.vala"
	self->priv->last_moving_player = p;
#line 2005 "ai.c"
	{
		gint j = 0;
#line 337 "../src/ai.vala"
		j = 0;
#line 2010 "ai.c"
		{
			gboolean _tmp1_ = FALSE;
#line 337 "../src/ai.vala"
			_tmp1_ = TRUE;
#line 337 "../src/ai.vala"
			while (TRUE) {
#line 337 "../src/ai.vala"
				if (!_tmp1_) {
#line 2019 "ai.c"
					gint _tmp2_;
#line 337 "../src/ai.vala"
					_tmp2_ = j;
#line 337 "../src/ai.vala"
					j = _tmp2_ + 1;
#line 2025 "ai.c"
				}
#line 337 "../src/ai.vala"
				_tmp1_ = FALSE;
#line 337 "../src/ai.vala"
				if (!(j < BOARD_COLUMNS)) {
#line 337 "../src/ai.vala"
					break;
#line 2033 "ai.c"
				}
				{
					gint i = 0;
#line 339 "../src/ai.vala"
					i = 0;
#line 2039 "ai.c"
					{
						gboolean _tmp3_ = FALSE;
#line 339 "../src/ai.vala"
						_tmp3_ = TRUE;
#line 339 "../src/ai.vala"
						while (TRUE) {
#line 2046 "ai.c"
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Player _tmp6_;
							Player* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							Player* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
#line 339 "../src/ai.vala"
							if (!_tmp3_) {
#line 2059 "ai.c"
								gint _tmp4_;
#line 339 "../src/ai.vala"
								_tmp4_ = i;
#line 339 "../src/ai.vala"
								i = _tmp4_ + 1;
#line 2065 "ai.c"
							}
#line 339 "../src/ai.vala"
							_tmp3_ = FALSE;
#line 339 "../src/ai.vala"
							if (!(i < BOARD_ROWS)) {
#line 339 "../src/ai.vala"
								break;
#line 2073 "ai.c"
							}
#line 341 "../src/ai.vala"
							_tmp5_ = self->priv->board;
#line 341 "../src/ai.vala"
							_tmp5__length1 = self->priv->board_length1;
#line 341 "../src/ai.vala"
							_tmp5__length2 = self->priv->board_length2;
#line 341 "../src/ai.vala"
							_tmp6_ = _tmp5_[(i * _tmp5__length2) + j];
#line 341 "../src/ai.vala"
							if (_tmp6_ != PLAYER_NONE) {
#line 342 "../src/ai.vala"
								break;
#line 2087 "ai.c"
							}
#line 344 "../src/ai.vala"
							if (decision_tree_all_adjacent_empty (self, i, j)) {
#line 345 "../src/ai.vala"
								continue;
#line 2093 "ai.c"
							}
#line 347 "../src/ai.vala"
							_tmp7_ = self->priv->board;
#line 347 "../src/ai.vala"
							_tmp7__length1 = self->priv->board_length1;
#line 347 "../src/ai.vala"
							_tmp7__length2 = self->priv->board_length2;
#line 347 "../src/ai.vala"
							_tmp7_[(i * _tmp7__length2) + j] = p;
#line 349 "../src/ai.vala"
							if (decision_tree_victory (self, j)) {
#line 2105 "ai.c"
								gint _tmp8_;
#line 350 "../src/ai.vala"
								_tmp8_ = count;
#line 350 "../src/ai.vala"
								count = _tmp8_ + 1;
#line 2111 "ai.c"
							}
#line 352 "../src/ai.vala"
							_tmp9_ = self->priv->board;
#line 352 "../src/ai.vala"
							_tmp9__length1 = self->priv->board_length1;
#line 352 "../src/ai.vala"
							_tmp9__length2 = self->priv->board_length2;
#line 352 "../src/ai.vala"
							_tmp9_[(i * _tmp9__length2) + j] = PLAYER_NONE;
#line 2121 "ai.c"
						}
					}
				}
			}
		}
	}
#line 355 "../src/ai.vala"
	_tmp10_ = old_last_moving_player;
#line 355 "../src/ai.vala"
	self->priv->last_moving_player = _tmp10_;
#line 356 "../src/ai.vala"
	result = count;
#line 356 "../src/ai.vala"
	return result;
#line 2136 "ai.c"
}

static gboolean
decision_tree_all_adjacent_empty (DecisionTree* self,
                                  gint i,
                                  gint j)
{
	gboolean result = FALSE;
#line 360 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2147 "ai.c"
	{
		gint k = 0;
#line 362 "../src/ai.vala"
		k = -1;
#line 2152 "ai.c"
		{
			gboolean _tmp0_ = FALSE;
#line 362 "../src/ai.vala"
			_tmp0_ = TRUE;
#line 362 "../src/ai.vala"
			while (TRUE) {
#line 362 "../src/ai.vala"
				if (!_tmp0_) {
#line 2161 "ai.c"
					gint _tmp1_;
#line 362 "../src/ai.vala"
					_tmp1_ = k;
#line 362 "../src/ai.vala"
					k = _tmp1_ + 1;
#line 2167 "ai.c"
				}
#line 362 "../src/ai.vala"
				_tmp0_ = FALSE;
#line 362 "../src/ai.vala"
				if (!(k <= 1)) {
#line 362 "../src/ai.vala"
					break;
#line 2175 "ai.c"
				}
				{
					gint l = 0;
#line 364 "../src/ai.vala"
					l = -1;
#line 2181 "ai.c"
					{
						gboolean _tmp2_ = FALSE;
#line 364 "../src/ai.vala"
						_tmp2_ = TRUE;
#line 364 "../src/ai.vala"
						while (TRUE) {
#line 2188 "ai.c"
							gboolean _tmp4_ = FALSE;
							gboolean _tmp5_ = FALSE;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gboolean _tmp8_ = FALSE;
#line 364 "../src/ai.vala"
							if (!_tmp2_) {
#line 2196 "ai.c"
								gint _tmp3_;
#line 364 "../src/ai.vala"
								_tmp3_ = l;
#line 364 "../src/ai.vala"
								l = _tmp3_ + 1;
#line 2202 "ai.c"
							}
#line 364 "../src/ai.vala"
							_tmp2_ = FALSE;
#line 364 "../src/ai.vala"
							if (!(l <= 1)) {
#line 364 "../src/ai.vala"
								break;
#line 2210 "ai.c"
							}
#line 366 "../src/ai.vala"
							if (k == 0) {
#line 366 "../src/ai.vala"
								_tmp4_ = l == 0;
#line 2216 "ai.c"
							} else {
#line 366 "../src/ai.vala"
								_tmp4_ = FALSE;
#line 2220 "ai.c"
							}
#line 366 "../src/ai.vala"
							if (_tmp4_) {
#line 367 "../src/ai.vala"
								continue;
#line 2226 "ai.c"
							}
#line 368 "../src/ai.vala"
							if ((i + k) >= 0) {
#line 368 "../src/ai.vala"
								_tmp8_ = (i + k) < BOARD_ROWS;
#line 2232 "ai.c"
							} else {
#line 368 "../src/ai.vala"
								_tmp8_ = FALSE;
#line 2236 "ai.c"
							}
#line 368 "../src/ai.vala"
							if (_tmp8_) {
#line 368 "../src/ai.vala"
								_tmp7_ = (j + l) >= 0;
#line 2242 "ai.c"
							} else {
#line 368 "../src/ai.vala"
								_tmp7_ = FALSE;
#line 2246 "ai.c"
							}
#line 368 "../src/ai.vala"
							if (_tmp7_) {
#line 368 "../src/ai.vala"
								_tmp6_ = (j + l) < BOARD_COLUMNS;
#line 2252 "ai.c"
							} else {
#line 368 "../src/ai.vala"
								_tmp6_ = FALSE;
#line 2256 "ai.c"
							}
#line 368 "../src/ai.vala"
							if (_tmp6_) {
#line 2260 "ai.c"
								Player* _tmp9_;
								gint _tmp9__length1;
								gint _tmp9__length2;
								Player _tmp10_;
#line 368 "../src/ai.vala"
								_tmp9_ = self->priv->board;
#line 368 "../src/ai.vala"
								_tmp9__length1 = self->priv->board_length1;
#line 368 "../src/ai.vala"
								_tmp9__length2 = self->priv->board_length2;
#line 368 "../src/ai.vala"
								_tmp10_ = _tmp9_[((i + k) * _tmp9__length2) + (j + l)];
#line 368 "../src/ai.vala"
								_tmp5_ = _tmp10_ != PLAYER_NONE;
#line 2275 "ai.c"
							} else {
#line 368 "../src/ai.vala"
								_tmp5_ = FALSE;
#line 2279 "ai.c"
							}
#line 368 "../src/ai.vala"
							if (_tmp5_) {
#line 369 "../src/ai.vala"
								result = FALSE;
#line 369 "../src/ai.vala"
								return result;
#line 2287 "ai.c"
							}
						}
					}
				}
			}
		}
	}
#line 373 "../src/ai.vala"
	result = TRUE;
#line 373 "../src/ai.vala"
	return result;
#line 2299 "ai.c"
}

static void
decision_tree_set_level (DecisionTree* self,
                         const gchar* vstr)
{
#line 377 "../src/ai.vala"
	g_return_if_fail (self != NULL);
#line 377 "../src/ai.vala"
	g_return_if_fail (vstr != NULL);
#line 379 "../src/ai.vala"
	if (string_get (vstr, (glong) 0) == 'a') {
#line 381 "../src/ai.vala"
		self->priv->level = DIFFICULTY_EASY;
#line 382 "../src/ai.vala"
		self->priv->plies = 4;
#line 2316 "ai.c"
	} else {
#line 384 "../src/ai.vala"
		if (string_get (vstr, (glong) 0) == 'b') {
#line 386 "../src/ai.vala"
			self->priv->level = DIFFICULTY_MEDIUM;
#line 387 "../src/ai.vala"
			self->priv->plies = 7;
#line 2324 "ai.c"
		} else {
#line 391 "../src/ai.vala"
			self->priv->level = DIFFICULTY_HARD;
#line 392 "../src/ai.vala"
			self->priv->plies = 7;
#line 2330 "ai.c"
		}
	}
}

gint
decision_tree_playandcheck (DecisionTree* self,
                            const gchar* vstr)
{
	gint result = 0;
	gint temp = 0;
#line 397 "../src/ai.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 397 "../src/ai.vala"
	g_return_val_if_fail (vstr != NULL, 0);
#line 399 "../src/ai.vala"
	decision_tree_set_level (self, vstr);
#line 400 "../src/ai.vala"
	decision_tree_update_board (self, vstr);
#line 402 "../src/ai.vala"
	temp = decision_tree_immediate_win (self, PLAYER_AI);
#line 403 "../src/ai.vala"
	if (temp != -1) {
#line 404 "../src/ai.vala"
		result = 1000;
#line 404 "../src/ai.vala"
		return result;
#line 2357 "ai.c"
	}
#line 406 "../src/ai.vala"
	temp = decision_tree_immediate_win (self, PLAYER_HUMAN);
#line 407 "../src/ai.vala"
	if (temp != -1) {
#line 408 "../src/ai.vala"
		result = temp + 1;
#line 408 "../src/ai.vala"
		return result;
#line 2367 "ai.c"
	}
#line 410 "../src/ai.vala"
	decision_tree_negamax (self, self->priv->plies, NEG_INF, -1 * NEG_INF);
#line 412 "../src/ai.vala"
	result = self->priv->next_move_in_column + 1;
#line 412 "../src/ai.vala"
	return result;
#line 2375 "ai.c"
}

static void
value_decision_tree_init (GValue* value)
{
#line 37 "../src/ai.vala"
	value->data[0].v_pointer = NULL;
#line 2383 "ai.c"
}

static void
value_decision_tree_free_value (GValue* value)
{
#line 37 "../src/ai.vala"
	if (value->data[0].v_pointer) {
#line 37 "../src/ai.vala"
		decision_tree_unref (value->data[0].v_pointer);
#line 2393 "ai.c"
	}
}

static void
value_decision_tree_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 37 "../src/ai.vala"
	if (src_value->data[0].v_pointer) {
#line 37 "../src/ai.vala"
		dest_value->data[0].v_pointer = decision_tree_ref (src_value->data[0].v_pointer);
#line 2405 "ai.c"
	} else {
#line 37 "../src/ai.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2409 "ai.c"
	}
}

static gpointer
value_decision_tree_peek_pointer (const GValue* value)
{
#line 37 "../src/ai.vala"
	return value->data[0].v_pointer;
#line 2418 "ai.c"
}

static gchar*
value_decision_tree_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 37 "../src/ai.vala"
	if (collect_values[0].v_pointer) {
#line 2429 "ai.c"
		DecisionTree * object;
		object = collect_values[0].v_pointer;
#line 37 "../src/ai.vala"
		if (object->parent_instance.g_class == NULL) {
#line 37 "../src/ai.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2436 "ai.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 37 "../src/ai.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2440 "ai.c"
		}
#line 37 "../src/ai.vala"
		value->data[0].v_pointer = decision_tree_ref (object);
#line 2444 "ai.c"
	} else {
#line 37 "../src/ai.vala"
		value->data[0].v_pointer = NULL;
#line 2448 "ai.c"
	}
#line 37 "../src/ai.vala"
	return NULL;
#line 2452 "ai.c"
}

static gchar*
value_decision_tree_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	DecisionTree ** object_p;
	object_p = collect_values[0].v_pointer;
#line 37 "../src/ai.vala"
	if (!object_p) {
#line 37 "../src/ai.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2467 "ai.c"
	}
#line 37 "../src/ai.vala"
	if (!value->data[0].v_pointer) {
#line 37 "../src/ai.vala"
		*object_p = NULL;
#line 2473 "ai.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 37 "../src/ai.vala"
		*object_p = value->data[0].v_pointer;
#line 2477 "ai.c"
	} else {
#line 37 "../src/ai.vala"
		*object_p = decision_tree_ref (value->data[0].v_pointer);
#line 2481 "ai.c"
	}
#line 37 "../src/ai.vala"
	return NULL;
#line 2485 "ai.c"
}

GParamSpec*
param_spec_decision_tree (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecDecisionTree* spec;
#line 37 "../src/ai.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DECISION_TREE), NULL);
#line 37 "../src/ai.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 37 "../src/ai.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 37 "../src/ai.vala"
	return G_PARAM_SPEC (spec);
#line 2504 "ai.c"
}

gpointer
value_get_decision_tree (const GValue* value)
{
#line 37 "../src/ai.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DECISION_TREE), NULL);
#line 37 "../src/ai.vala"
	return value->data[0].v_pointer;
#line 2514 "ai.c"
}

void
value_set_decision_tree (GValue* value,
                         gpointer v_object)
{
	DecisionTree * old;
#line 37 "../src/ai.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DECISION_TREE));
#line 37 "../src/ai.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/ai.vala"
	if (v_object) {
#line 37 "../src/ai.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DECISION_TREE));
#line 37 "../src/ai.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/ai.vala"
		value->data[0].v_pointer = v_object;
#line 37 "../src/ai.vala"
		decision_tree_ref (value->data[0].v_pointer);
#line 2536 "ai.c"
	} else {
#line 37 "../src/ai.vala"
		value->data[0].v_pointer = NULL;
#line 2540 "ai.c"
	}
#line 37 "../src/ai.vala"
	if (old) {
#line 37 "../src/ai.vala"
		decision_tree_unref (old);
#line 2546 "ai.c"
	}
}

void
value_take_decision_tree (GValue* value,
                          gpointer v_object)
{
	DecisionTree * old;
#line 37 "../src/ai.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DECISION_TREE));
#line 37 "../src/ai.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/ai.vala"
	if (v_object) {
#line 37 "../src/ai.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DECISION_TREE));
#line 37 "../src/ai.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/ai.vala"
		value->data[0].v_pointer = v_object;
#line 2567 "ai.c"
	} else {
#line 37 "../src/ai.vala"
		value->data[0].v_pointer = NULL;
#line 2571 "ai.c"
	}
#line 37 "../src/ai.vala"
	if (old) {
#line 37 "../src/ai.vala"
		decision_tree_unref (old);
#line 2577 "ai.c"
	}
}

static void
decision_tree_class_init (DecisionTreeClass * klass,
                          gpointer klass_data)
{
#line 37 "../src/ai.vala"
	decision_tree_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/ai.vala"
	((DecisionTreeClass *) klass)->finalize = decision_tree_finalize;
#line 37 "../src/ai.vala"
	g_type_class_adjust_private_offset (klass, &DecisionTree_private_offset);
#line 2591 "ai.c"
}

static void
decision_tree_instance_init (DecisionTree * self,
                             gpointer klass)
{
	Player* _tmp0_;
#line 37 "../src/ai.vala"
	self->priv = decision_tree_get_instance_private (self);
#line 40 "../src/ai.vala"
	_tmp0_ = g_new0 (Player, BOARD_ROWS * BOARD_COLUMNS);
#line 40 "../src/ai.vala"
	self->priv->board = _tmp0_;
#line 40 "../src/ai.vala"
	self->priv->board_length1 = BOARD_ROWS;
#line 40 "../src/ai.vala"
	self->priv->board_length2 = BOARD_COLUMNS;
#line 42 "../src/ai.vala"
	self->priv->plies = 8;
#line 44 "../src/ai.vala"
	self->priv->last_moving_player = PLAYER_NONE;
#line 46 "../src/ai.vala"
	self->priv->next_move_in_column = -1;
#line 37 "../src/ai.vala"
	self->ref_count = 1;
#line 2617 "ai.c"
}

static void
decision_tree_finalize (DecisionTree * obj)
{
	DecisionTree * self;
#line 37 "../src/ai.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DECISION_TREE, DecisionTree);
#line 37 "../src/ai.vala"
	g_signal_handlers_destroy (self);
#line 40 "../src/ai.vala"
	self->priv->board = (g_free (self->priv->board), NULL);
#line 2630 "ai.c"
}

GType
decision_tree_get_type (void)
{
	static volatile gsize decision_tree_type_id__volatile = 0;
	if (g_once_init_enter (&decision_tree_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_decision_tree_init, value_decision_tree_free_value, value_decision_tree_copy_value, value_decision_tree_peek_pointer, "p", value_decision_tree_collect_value, "p", value_decision_tree_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DecisionTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) decision_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DecisionTree), 0, (GInstanceInitFunc) decision_tree_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType decision_tree_type_id;
		decision_tree_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DecisionTree", &g_define_type_info, &g_define_type_fundamental_info, 0);
		DecisionTree_private_offset = g_type_add_instance_private (decision_tree_type_id, sizeof (DecisionTreePrivate));
		g_once_init_leave (&decision_tree_type_id__volatile, decision_tree_type_id);
	}
	return decision_tree_type_id__volatile;
}

gpointer
decision_tree_ref (gpointer instance)
{
	DecisionTree * self;
	self = instance;
#line 37 "../src/ai.vala"
	g_atomic_int_inc (&self->ref_count);
#line 37 "../src/ai.vala"
	return instance;
#line 2658 "ai.c"
}

void
decision_tree_unref (gpointer instance)
{
	DecisionTree * self;
	self = instance;
#line 37 "../src/ai.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 37 "../src/ai.vala"
		DECISION_TREE_GET_CLASS (self)->finalize (self);
#line 37 "../src/ai.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2672 "ai.c"
	}
}

