/* game-board.c generated by valac 0.43.92, the Vala compiler
 * generated from game-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* game_board.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;
typedef struct _BoardPrivate BoardPrivate;
enum  {
	BOARD_0_PROPERTY,
	BOARD_NUM_PROPERTIES
};
static GParamSpec* board_properties[BOARD_NUM_PROPERTIES];
typedef enum  {
	TILE_PLAYER1 = 0,
	TILE_PLAYER2,
	TILE_CLEAR,
	TILE_CLEAR_CURSOR,
	TILE_PLAYER1_CURSOR,
	TILE_PLAYER2_CURSOR
} Tile;

#define TYPE_TILE (tile_get_type ())

struct _Board {
	GObject parent_instance;
	BoardPrivate * priv;
};

struct _BoardClass {
	GObjectClass parent_class;
};

static gpointer board_parent_class = NULL;
static Tile* board_gboard;
static gint board_gboard_length1;
static gint board_gboard_length2;
static Tile* board_gboard = NULL;
static gint board_gboard_length1 = 0;
static gint board_gboard_length2 = 0;

GType board_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, g_object_unref)
GType tile_get_type (void) G_GNUC_CONST;
#define BOARD_BOARD_SIZE 7
Board* board_new (void);
Board* board_construct (GType object_type);
void board_set (Board* self,
                gint x,
                gint y,
                Tile tile);
Tile board_get (Board* self,
                gint x,
                gint y);
void board_clear (Board* self);
gint board_first_empty_row (Board* self,
                            gint c);
static gboolean board_is_hline_at (Board* self,
                            Tile p,
                            gint r,
                            gint c,
                            gint* r1,
                            gint* c1,
                            gint* r2,
                            gint* c2);
gboolean board_is_line_at (Board* self,
                           Tile p,
                           gint r,
                           gint c,
                           gint* r1,
                           gint* c1,
                           gint* r2,
                           gint* c2);
static gboolean board_is_vline_at (Board* self,
                            Tile p,
                            gint r,
                            gint c,
                            gint* r1,
                            gint* c1,
                            gint* r2,
                            gint* c2);
static gboolean board_is_dline1_at (Board* self,
                             Tile p,
                             gint r,
                             gint c,
                             gint* r1,
                             gint* c1,
                             gint* r2,
                             gint* c2);
static gboolean board_is_dline2_at (Board* self,
                             Tile p,
                             gint r,
                             gint c,
                             gint* r1,
                             gint* c1,
                             gint* r2,
                             gint* c2);
static void board_finalize (GObject * obj);

Board*
board_construct (GType object_type)
{
	Board * self = NULL;
	Tile* _tmp0_;
#line 26 "../src/game-board.vala"
	self = (Board*) g_object_new (object_type, NULL);
#line 27 "../src/game-board.vala"
	_tmp0_ = g_new0 (Tile, BOARD_BOARD_SIZE * BOARD_BOARD_SIZE);
#line 27 "../src/game-board.vala"
	board_gboard = (g_free (board_gboard), NULL);
#line 27 "../src/game-board.vala"
	board_gboard = _tmp0_;
#line 27 "../src/game-board.vala"
	board_gboard_length1 = BOARD_BOARD_SIZE;
#line 27 "../src/game-board.vala"
	board_gboard_length2 = BOARD_BOARD_SIZE;
#line 26 "../src/game-board.vala"
	return self;
#line 149 "game-board.c"
}

Board*
board_new (void)
{
#line 26 "../src/game-board.vala"
	return board_construct (TYPE_BOARD);
#line 157 "game-board.c"
}

void
board_set (Board* self,
           gint x,
           gint y,
           Tile tile)
{
	Tile* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 30 "../src/game-board.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/game-board.vala"
	_tmp0_ = board_gboard;
#line 31 "../src/game-board.vala"
	_tmp0__length1 = board_gboard_length1;
#line 31 "../src/game-board.vala"
	_tmp0__length2 = board_gboard_length2;
#line 31 "../src/game-board.vala"
	_tmp0_[(x * _tmp0__length2) + y] = tile;
#line 179 "game-board.c"
}

Tile
board_get (Board* self,
           gint x,
           gint y)
{
	Tile result = 0;
	Tile* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile _tmp1_;
#line 34 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../src/game-board.vala"
	_tmp0_ = board_gboard;
#line 35 "../src/game-board.vala"
	_tmp0__length1 = board_gboard_length1;
#line 35 "../src/game-board.vala"
	_tmp0__length2 = board_gboard_length2;
#line 35 "../src/game-board.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 35 "../src/game-board.vala"
	result = _tmp1_;
#line 35 "../src/game-board.vala"
	return result;
#line 206 "game-board.c"
}

void
board_clear (Board* self)
{
#line 38 "../src/game-board.vala"
	g_return_if_fail (self != NULL);
#line 214 "game-board.c"
	{
		gint r = 0;
#line 39 "../src/game-board.vala"
		r = 0;
#line 219 "game-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 39 "../src/game-board.vala"
			_tmp0_ = TRUE;
#line 39 "../src/game-board.vala"
			while (TRUE) {
#line 39 "../src/game-board.vala"
				if (!_tmp0_) {
#line 228 "game-board.c"
					gint _tmp1_;
#line 39 "../src/game-board.vala"
					_tmp1_ = r;
#line 39 "../src/game-board.vala"
					r = _tmp1_ + 1;
#line 234 "game-board.c"
				}
#line 39 "../src/game-board.vala"
				_tmp0_ = FALSE;
#line 39 "../src/game-board.vala"
				if (!(r < BOARD_BOARD_SIZE)) {
#line 39 "../src/game-board.vala"
					break;
#line 242 "game-board.c"
				}
				{
					gint c = 0;
#line 40 "../src/game-board.vala"
					c = 0;
#line 248 "game-board.c"
					{
						gboolean _tmp2_ = FALSE;
#line 40 "../src/game-board.vala"
						_tmp2_ = TRUE;
#line 40 "../src/game-board.vala"
						while (TRUE) {
#line 255 "game-board.c"
							Tile* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
#line 40 "../src/game-board.vala"
							if (!_tmp2_) {
#line 261 "game-board.c"
								gint _tmp3_;
#line 40 "../src/game-board.vala"
								_tmp3_ = c;
#line 40 "../src/game-board.vala"
								c = _tmp3_ + 1;
#line 267 "game-board.c"
							}
#line 40 "../src/game-board.vala"
							_tmp2_ = FALSE;
#line 40 "../src/game-board.vala"
							if (!(c < BOARD_BOARD_SIZE)) {
#line 40 "../src/game-board.vala"
								break;
#line 275 "game-board.c"
							}
#line 41 "../src/game-board.vala"
							_tmp4_ = board_gboard;
#line 41 "../src/game-board.vala"
							_tmp4__length1 = board_gboard_length1;
#line 41 "../src/game-board.vala"
							_tmp4__length2 = board_gboard_length2;
#line 41 "../src/game-board.vala"
							_tmp4_[(r * _tmp4__length2) + c] = TILE_CLEAR;
#line 285 "game-board.c"
						}
					}
				}
			}
		}
	}
}

gint
board_first_empty_row (Board* self,
                       gint c)
{
	gint result = 0;
	gint r = 0;
#line 46 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../src/game-board.vala"
	r = 1;
#line 49 "../src/game-board.vala"
	while (TRUE) {
#line 306 "game-board.c"
		gboolean _tmp0_ = FALSE;
		gint _tmp3_;
#line 49 "../src/game-board.vala"
		if (r < BOARD_BOARD_SIZE) {
#line 311 "game-board.c"
			Tile* _tmp1_;
			gint _tmp1__length1;
			gint _tmp1__length2;
			Tile _tmp2_;
#line 49 "../src/game-board.vala"
			_tmp1_ = board_gboard;
#line 49 "../src/game-board.vala"
			_tmp1__length1 = board_gboard_length1;
#line 49 "../src/game-board.vala"
			_tmp1__length2 = board_gboard_length2;
#line 49 "../src/game-board.vala"
			_tmp2_ = _tmp1_[(r * _tmp1__length2) + c];
#line 49 "../src/game-board.vala"
			_tmp0_ = _tmp2_ == TILE_CLEAR;
#line 326 "game-board.c"
		} else {
#line 49 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 330 "game-board.c"
		}
#line 49 "../src/game-board.vala"
		if (!_tmp0_) {
#line 49 "../src/game-board.vala"
			break;
#line 336 "game-board.c"
		}
#line 50 "../src/game-board.vala"
		_tmp3_ = r;
#line 50 "../src/game-board.vala"
		r = _tmp3_ + 1;
#line 342 "game-board.c"
	}
#line 51 "../src/game-board.vala"
	result = r - 1;
#line 51 "../src/game-board.vala"
	return result;
#line 348 "game-board.c"
}

static gboolean
board_is_hline_at (Board* self,
                   Tile p,
                   gint r,
                   gint c,
                   gint* r1,
                   gint* c1,
                   gint* r2,
                   gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
#line 54 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/game-board.vala"
	_vala_r1 = r;
#line 56 "../src/game-board.vala"
	_vala_r2 = r;
#line 57 "../src/game-board.vala"
	_vala_c1 = c;
#line 58 "../src/game-board.vala"
	_vala_c2 = c;
#line 59 "../src/game-board.vala"
	while (TRUE) {
#line 378 "game-board.c"
		gboolean _tmp0_ = FALSE;
#line 59 "../src/game-board.vala"
		if (_vala_c1 > 0) {
#line 382 "game-board.c"
			Tile* _tmp1_;
			gint _tmp1__length1;
			gint _tmp1__length2;
			Tile _tmp2_;
#line 59 "../src/game-board.vala"
			_tmp1_ = board_gboard;
#line 59 "../src/game-board.vala"
			_tmp1__length1 = board_gboard_length1;
#line 59 "../src/game-board.vala"
			_tmp1__length2 = board_gboard_length2;
#line 59 "../src/game-board.vala"
			_tmp2_ = _tmp1_[(r * _tmp1__length2) + (_vala_c1 - 1)];
#line 59 "../src/game-board.vala"
			_tmp0_ = _tmp2_ == p;
#line 397 "game-board.c"
		} else {
#line 59 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 401 "game-board.c"
		}
#line 59 "../src/game-board.vala"
		if (!_tmp0_) {
#line 59 "../src/game-board.vala"
			break;
#line 407 "game-board.c"
		}
#line 60 "../src/game-board.vala"
		_vala_c1 = _vala_c1 - 1;
#line 411 "game-board.c"
	}
#line 61 "../src/game-board.vala"
	while (TRUE) {
#line 415 "game-board.c"
		gboolean _tmp3_ = FALSE;
#line 61 "../src/game-board.vala"
		if (_vala_c2 < 6) {
#line 419 "game-board.c"
			Tile* _tmp4_;
			gint _tmp4__length1;
			gint _tmp4__length2;
			Tile _tmp5_;
#line 61 "../src/game-board.vala"
			_tmp4_ = board_gboard;
#line 61 "../src/game-board.vala"
			_tmp4__length1 = board_gboard_length1;
#line 61 "../src/game-board.vala"
			_tmp4__length2 = board_gboard_length2;
#line 61 "../src/game-board.vala"
			_tmp5_ = _tmp4_[(r * _tmp4__length2) + (_vala_c2 + 1)];
#line 61 "../src/game-board.vala"
			_tmp3_ = _tmp5_ == p;
#line 434 "game-board.c"
		} else {
#line 61 "../src/game-board.vala"
			_tmp3_ = FALSE;
#line 438 "game-board.c"
		}
#line 61 "../src/game-board.vala"
		if (!_tmp3_) {
#line 61 "../src/game-board.vala"
			break;
#line 444 "game-board.c"
		}
#line 62 "../src/game-board.vala"
		_vala_c2 = _vala_c2 + 1;
#line 448 "game-board.c"
	}
#line 63 "../src/game-board.vala"
	if ((_vala_c2 - _vala_c1) >= 3) {
#line 64 "../src/game-board.vala"
		result = TRUE;
#line 64 "../src/game-board.vala"
		if (r1) {
#line 64 "../src/game-board.vala"
			*r1 = _vala_r1;
#line 458 "game-board.c"
		}
#line 64 "../src/game-board.vala"
		if (c1) {
#line 64 "../src/game-board.vala"
			*c1 = _vala_c1;
#line 464 "game-board.c"
		}
#line 64 "../src/game-board.vala"
		if (r2) {
#line 64 "../src/game-board.vala"
			*r2 = _vala_r2;
#line 470 "game-board.c"
		}
#line 64 "../src/game-board.vala"
		if (c2) {
#line 64 "../src/game-board.vala"
			*c2 = _vala_c2;
#line 476 "game-board.c"
		}
#line 64 "../src/game-board.vala"
		return result;
#line 480 "game-board.c"
	}
#line 65 "../src/game-board.vala"
	result = FALSE;
#line 65 "../src/game-board.vala"
	if (r1) {
#line 65 "../src/game-board.vala"
		*r1 = _vala_r1;
#line 488 "game-board.c"
	}
#line 65 "../src/game-board.vala"
	if (c1) {
#line 65 "../src/game-board.vala"
		*c1 = _vala_c1;
#line 494 "game-board.c"
	}
#line 65 "../src/game-board.vala"
	if (r2) {
#line 65 "../src/game-board.vala"
		*r2 = _vala_r2;
#line 500 "game-board.c"
	}
#line 65 "../src/game-board.vala"
	if (c2) {
#line 65 "../src/game-board.vala"
		*c2 = _vala_c2;
#line 506 "game-board.c"
	}
#line 65 "../src/game-board.vala"
	return result;
#line 510 "game-board.c"
}

gboolean
board_is_line_at (Board* self,
                  Tile p,
                  gint r,
                  gint c,
                  gint* r1,
                  gint* c1,
                  gint* r2,
                  gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_;
#line 68 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "../src/game-board.vala"
	_tmp7_ = board_is_hline_at (self, p, r, c, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 70 "../src/game-board.vala"
	_vala_r1 = _tmp3_;
#line 70 "../src/game-board.vala"
	_vala_c1 = _tmp4_;
#line 70 "../src/game-board.vala"
	_vala_r2 = _tmp5_;
#line 70 "../src/game-board.vala"
	_vala_c2 = _tmp6_;
#line 70 "../src/game-board.vala"
	if (_tmp7_) {
#line 70 "../src/game-board.vala"
		_tmp2_ = TRUE;
#line 552 "game-board.c"
	} else {
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gboolean _tmp12_;
#line 71 "../src/game-board.vala"
		_tmp12_ = board_is_vline_at (self, p, r, c, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 71 "../src/game-board.vala"
		_vala_r1 = _tmp8_;
#line 71 "../src/game-board.vala"
		_vala_c1 = _tmp9_;
#line 71 "../src/game-board.vala"
		_vala_r2 = _tmp10_;
#line 71 "../src/game-board.vala"
		_vala_c2 = _tmp11_;
#line 71 "../src/game-board.vala"
		_tmp2_ = _tmp12_;
#line 571 "game-board.c"
	}
#line 70 "../src/game-board.vala"
	if (_tmp2_) {
#line 70 "../src/game-board.vala"
		_tmp1_ = TRUE;
#line 577 "game-board.c"
	} else {
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gboolean _tmp17_;
#line 72 "../src/game-board.vala"
		_tmp17_ = board_is_dline1_at (self, p, r, c, &_tmp13_, &_tmp14_, &_tmp15_, &_tmp16_);
#line 72 "../src/game-board.vala"
		_vala_r1 = _tmp13_;
#line 72 "../src/game-board.vala"
		_vala_c1 = _tmp14_;
#line 72 "../src/game-board.vala"
		_vala_r2 = _tmp15_;
#line 72 "../src/game-board.vala"
		_vala_c2 = _tmp16_;
#line 72 "../src/game-board.vala"
		_tmp1_ = _tmp17_;
#line 596 "game-board.c"
	}
#line 70 "../src/game-board.vala"
	if (_tmp1_) {
#line 70 "../src/game-board.vala"
		_tmp0_ = TRUE;
#line 602 "game-board.c"
	} else {
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
		gint _tmp21_ = 0;
		gboolean _tmp22_;
#line 73 "../src/game-board.vala"
		_tmp22_ = board_is_dline2_at (self, p, r, c, &_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_);
#line 73 "../src/game-board.vala"
		_vala_r1 = _tmp18_;
#line 73 "../src/game-board.vala"
		_vala_c1 = _tmp19_;
#line 73 "../src/game-board.vala"
		_vala_r2 = _tmp20_;
#line 73 "../src/game-board.vala"
		_vala_c2 = _tmp21_;
#line 73 "../src/game-board.vala"
		_tmp0_ = _tmp22_;
#line 621 "game-board.c"
	}
#line 70 "../src/game-board.vala"
	result = _tmp0_;
#line 70 "../src/game-board.vala"
	if (r1) {
#line 70 "../src/game-board.vala"
		*r1 = _vala_r1;
#line 629 "game-board.c"
	}
#line 70 "../src/game-board.vala"
	if (c1) {
#line 70 "../src/game-board.vala"
		*c1 = _vala_c1;
#line 635 "game-board.c"
	}
#line 70 "../src/game-board.vala"
	if (r2) {
#line 70 "../src/game-board.vala"
		*r2 = _vala_r2;
#line 641 "game-board.c"
	}
#line 70 "../src/game-board.vala"
	if (c2) {
#line 70 "../src/game-board.vala"
		*c2 = _vala_c2;
#line 647 "game-board.c"
	}
#line 70 "../src/game-board.vala"
	return result;
#line 651 "game-board.c"
}

static gboolean
board_is_vline_at (Board* self,
                   Tile p,
                   gint r,
                   gint c,
                   gint* r1,
                   gint* c1,
                   gint* r2,
                   gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
#line 76 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/game-board.vala"
	_vala_r1 = r;
#line 78 "../src/game-board.vala"
	_vala_r2 = r;
#line 79 "../src/game-board.vala"
	_vala_c1 = c;
#line 80 "../src/game-board.vala"
	_vala_c2 = c;
#line 81 "../src/game-board.vala"
	while (TRUE) {
#line 681 "game-board.c"
		gboolean _tmp0_ = FALSE;
#line 81 "../src/game-board.vala"
		if (_vala_r1 > 1) {
#line 81 "../src/game-board.vala"
			_tmp0_ = board_get (self, _vala_r1 - 1, c) == p;
#line 687 "game-board.c"
		} else {
#line 81 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 691 "game-board.c"
		}
#line 81 "../src/game-board.vala"
		if (!_tmp0_) {
#line 81 "../src/game-board.vala"
			break;
#line 697 "game-board.c"
		}
#line 82 "../src/game-board.vala"
		_vala_r1 = _vala_r1 - 1;
#line 701 "game-board.c"
	}
#line 83 "../src/game-board.vala"
	while (TRUE) {
#line 705 "game-board.c"
		gboolean _tmp1_ = FALSE;
#line 83 "../src/game-board.vala"
		if (_vala_r2 < 6) {
#line 83 "../src/game-board.vala"
			_tmp1_ = board_get (self, _vala_r2 + 1, c) == p;
#line 711 "game-board.c"
		} else {
#line 83 "../src/game-board.vala"
			_tmp1_ = FALSE;
#line 715 "game-board.c"
		}
#line 83 "../src/game-board.vala"
		if (!_tmp1_) {
#line 83 "../src/game-board.vala"
			break;
#line 721 "game-board.c"
		}
#line 84 "../src/game-board.vala"
		_vala_r2 = _vala_r2 + 1;
#line 725 "game-board.c"
	}
#line 85 "../src/game-board.vala"
	if ((_vala_r2 - _vala_r1) >= 3) {
#line 86 "../src/game-board.vala"
		result = TRUE;
#line 86 "../src/game-board.vala"
		if (r1) {
#line 86 "../src/game-board.vala"
			*r1 = _vala_r1;
#line 735 "game-board.c"
		}
#line 86 "../src/game-board.vala"
		if (c1) {
#line 86 "../src/game-board.vala"
			*c1 = _vala_c1;
#line 741 "game-board.c"
		}
#line 86 "../src/game-board.vala"
		if (r2) {
#line 86 "../src/game-board.vala"
			*r2 = _vala_r2;
#line 747 "game-board.c"
		}
#line 86 "../src/game-board.vala"
		if (c2) {
#line 86 "../src/game-board.vala"
			*c2 = _vala_c2;
#line 753 "game-board.c"
		}
#line 86 "../src/game-board.vala"
		return result;
#line 757 "game-board.c"
	}
#line 87 "../src/game-board.vala"
	result = FALSE;
#line 87 "../src/game-board.vala"
	if (r1) {
#line 87 "../src/game-board.vala"
		*r1 = _vala_r1;
#line 765 "game-board.c"
	}
#line 87 "../src/game-board.vala"
	if (c1) {
#line 87 "../src/game-board.vala"
		*c1 = _vala_c1;
#line 771 "game-board.c"
	}
#line 87 "../src/game-board.vala"
	if (r2) {
#line 87 "../src/game-board.vala"
		*r2 = _vala_r2;
#line 777 "game-board.c"
	}
#line 87 "../src/game-board.vala"
	if (c2) {
#line 87 "../src/game-board.vala"
		*c2 = _vala_c2;
#line 783 "game-board.c"
	}
#line 87 "../src/game-board.vala"
	return result;
#line 787 "game-board.c"
}

static gboolean
board_is_dline1_at (Board* self,
                    Tile p,
                    gint r,
                    gint c,
                    gint* r1,
                    gint* c1,
                    gint* r2,
                    gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
#line 90 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "../src/game-board.vala"
	_vala_r1 = r;
#line 93 "../src/game-board.vala"
	_vala_r2 = r;
#line 94 "../src/game-board.vala"
	_vala_c1 = c;
#line 95 "../src/game-board.vala"
	_vala_c2 = c;
#line 96 "../src/game-board.vala"
	while (TRUE) {
#line 817 "game-board.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
#line 96 "../src/game-board.vala"
		if (_vala_c1 > 0) {
#line 96 "../src/game-board.vala"
			_tmp1_ = _vala_r1 > 1;
#line 824 "game-board.c"
		} else {
#line 96 "../src/game-board.vala"
			_tmp1_ = FALSE;
#line 828 "game-board.c"
		}
#line 96 "../src/game-board.vala"
		if (_tmp1_) {
#line 96 "../src/game-board.vala"
			_tmp0_ = board_get (self, _vala_r1 - 1, _vala_c1 - 1) == p;
#line 834 "game-board.c"
		} else {
#line 96 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 838 "game-board.c"
		}
#line 96 "../src/game-board.vala"
		if (!_tmp0_) {
#line 96 "../src/game-board.vala"
			break;
#line 844 "game-board.c"
		}
#line 97 "../src/game-board.vala"
		_vala_r1 = _vala_r1 - 1;
#line 98 "../src/game-board.vala"
		_vala_c1 = _vala_c1 - 1;
#line 850 "game-board.c"
	}
#line 100 "../src/game-board.vala"
	while (TRUE) {
#line 854 "game-board.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
#line 100 "../src/game-board.vala"
		if (_vala_c2 < 6) {
#line 100 "../src/game-board.vala"
			_tmp3_ = _vala_r2 < 6;
#line 861 "game-board.c"
		} else {
#line 100 "../src/game-board.vala"
			_tmp3_ = FALSE;
#line 865 "game-board.c"
		}
#line 100 "../src/game-board.vala"
		if (_tmp3_) {
#line 100 "../src/game-board.vala"
			_tmp2_ = board_get (self, _vala_r2 + 1, _vala_c2 + 1) == p;
#line 871 "game-board.c"
		} else {
#line 100 "../src/game-board.vala"
			_tmp2_ = FALSE;
#line 875 "game-board.c"
		}
#line 100 "../src/game-board.vala"
		if (!_tmp2_) {
#line 100 "../src/game-board.vala"
			break;
#line 881 "game-board.c"
		}
#line 101 "../src/game-board.vala"
		_vala_r2 = _vala_r2 + 1;
#line 102 "../src/game-board.vala"
		_vala_c2 = _vala_c2 + 1;
#line 887 "game-board.c"
	}
#line 104 "../src/game-board.vala"
	if ((_vala_r2 - _vala_r1) >= 3) {
#line 105 "../src/game-board.vala"
		result = TRUE;
#line 105 "../src/game-board.vala"
		if (r1) {
#line 105 "../src/game-board.vala"
			*r1 = _vala_r1;
#line 897 "game-board.c"
		}
#line 105 "../src/game-board.vala"
		if (c1) {
#line 105 "../src/game-board.vala"
			*c1 = _vala_c1;
#line 903 "game-board.c"
		}
#line 105 "../src/game-board.vala"
		if (r2) {
#line 105 "../src/game-board.vala"
			*r2 = _vala_r2;
#line 909 "game-board.c"
		}
#line 105 "../src/game-board.vala"
		if (c2) {
#line 105 "../src/game-board.vala"
			*c2 = _vala_c2;
#line 915 "game-board.c"
		}
#line 105 "../src/game-board.vala"
		return result;
#line 919 "game-board.c"
	}
#line 106 "../src/game-board.vala"
	result = FALSE;
#line 106 "../src/game-board.vala"
	if (r1) {
#line 106 "../src/game-board.vala"
		*r1 = _vala_r1;
#line 927 "game-board.c"
	}
#line 106 "../src/game-board.vala"
	if (c1) {
#line 106 "../src/game-board.vala"
		*c1 = _vala_c1;
#line 933 "game-board.c"
	}
#line 106 "../src/game-board.vala"
	if (r2) {
#line 106 "../src/game-board.vala"
		*r2 = _vala_r2;
#line 939 "game-board.c"
	}
#line 106 "../src/game-board.vala"
	if (c2) {
#line 106 "../src/game-board.vala"
		*c2 = _vala_c2;
#line 945 "game-board.c"
	}
#line 106 "../src/game-board.vala"
	return result;
#line 949 "game-board.c"
}

static gboolean
board_is_dline2_at (Board* self,
                    Tile p,
                    gint r,
                    gint c,
                    gint* r1,
                    gint* c1,
                    gint* r2,
                    gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
#line 109 "../src/game-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../src/game-board.vala"
	_vala_r1 = r;
#line 112 "../src/game-board.vala"
	_vala_r2 = r;
#line 113 "../src/game-board.vala"
	_vala_c1 = c;
#line 114 "../src/game-board.vala"
	_vala_c2 = c;
#line 115 "../src/game-board.vala"
	while (TRUE) {
#line 979 "game-board.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
#line 115 "../src/game-board.vala"
		if (_vala_c1 < 6) {
#line 115 "../src/game-board.vala"
			_tmp1_ = _vala_r1 > 1;
#line 986 "game-board.c"
		} else {
#line 115 "../src/game-board.vala"
			_tmp1_ = FALSE;
#line 990 "game-board.c"
		}
#line 115 "../src/game-board.vala"
		if (_tmp1_) {
#line 115 "../src/game-board.vala"
			_tmp0_ = board_get (self, _vala_r1 - 1, _vala_c1 + 1) == p;
#line 996 "game-board.c"
		} else {
#line 115 "../src/game-board.vala"
			_tmp0_ = FALSE;
#line 1000 "game-board.c"
		}
#line 115 "../src/game-board.vala"
		if (!_tmp0_) {
#line 115 "../src/game-board.vala"
			break;
#line 1006 "game-board.c"
		}
#line 116 "../src/game-board.vala"
		_vala_r1 = _vala_r1 - 1;
#line 117 "../src/game-board.vala"
		_vala_c1 = _vala_c1 + 1;
#line 1012 "game-board.c"
	}
#line 119 "../src/game-board.vala"
	while (TRUE) {
#line 1016 "game-board.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
#line 119 "../src/game-board.vala"
		if (_vala_c2 > 0) {
#line 119 "../src/game-board.vala"
			_tmp3_ = _vala_r2 < 6;
#line 1023 "game-board.c"
		} else {
#line 119 "../src/game-board.vala"
			_tmp3_ = FALSE;
#line 1027 "game-board.c"
		}
#line 119 "../src/game-board.vala"
		if (_tmp3_) {
#line 119 "../src/game-board.vala"
			_tmp2_ = board_get (self, _vala_r2 + 1, _vala_c2 - 1) == p;
#line 1033 "game-board.c"
		} else {
#line 119 "../src/game-board.vala"
			_tmp2_ = FALSE;
#line 1037 "game-board.c"
		}
#line 119 "../src/game-board.vala"
		if (!_tmp2_) {
#line 119 "../src/game-board.vala"
			break;
#line 1043 "game-board.c"
		}
#line 120 "../src/game-board.vala"
		_vala_r2 = _vala_r2 + 1;
#line 121 "../src/game-board.vala"
		_vala_c2 = _vala_c2 - 1;
#line 1049 "game-board.c"
	}
#line 123 "../src/game-board.vala"
	if ((_vala_r2 - _vala_r1) >= 3) {
#line 124 "../src/game-board.vala"
		result = TRUE;
#line 124 "../src/game-board.vala"
		if (r1) {
#line 124 "../src/game-board.vala"
			*r1 = _vala_r1;
#line 1059 "game-board.c"
		}
#line 124 "../src/game-board.vala"
		if (c1) {
#line 124 "../src/game-board.vala"
			*c1 = _vala_c1;
#line 1065 "game-board.c"
		}
#line 124 "../src/game-board.vala"
		if (r2) {
#line 124 "../src/game-board.vala"
			*r2 = _vala_r2;
#line 1071 "game-board.c"
		}
#line 124 "../src/game-board.vala"
		if (c2) {
#line 124 "../src/game-board.vala"
			*c2 = _vala_c2;
#line 1077 "game-board.c"
		}
#line 124 "../src/game-board.vala"
		return result;
#line 1081 "game-board.c"
	}
#line 125 "../src/game-board.vala"
	result = FALSE;
#line 125 "../src/game-board.vala"
	if (r1) {
#line 125 "../src/game-board.vala"
		*r1 = _vala_r1;
#line 1089 "game-board.c"
	}
#line 125 "../src/game-board.vala"
	if (c1) {
#line 125 "../src/game-board.vala"
		*c1 = _vala_c1;
#line 1095 "game-board.c"
	}
#line 125 "../src/game-board.vala"
	if (r2) {
#line 125 "../src/game-board.vala"
		*r2 = _vala_r2;
#line 1101 "game-board.c"
	}
#line 125 "../src/game-board.vala"
	if (c2) {
#line 125 "../src/game-board.vala"
		*c2 = _vala_c2;
#line 1107 "game-board.c"
	}
#line 125 "../src/game-board.vala"
	return result;
#line 1111 "game-board.c"
}

static void
board_class_init (BoardClass * klass,
                  gpointer klass_data)
{
#line 22 "../src/game-board.vala"
	board_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/game-board.vala"
	G_OBJECT_CLASS (klass)->finalize = board_finalize;
#line 1122 "game-board.c"
}

static void
board_instance_init (Board * self,
                     gpointer klass)
{
}

static void
board_finalize (GObject * obj)
{
	Board * self;
#line 22 "../src/game-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD, Board);
#line 22 "../src/game-board.vala"
	G_OBJECT_CLASS (board_parent_class)->finalize (obj);
#line 1139 "game-board.c"
}

GType
board_get_type (void)
{
	static volatile gsize board_type_id__volatile = 0;
	if (g_once_init_enter (&board_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Board), 0, (GInstanceInitFunc) board_instance_init, NULL };
		GType board_type_id;
		board_type_id = g_type_register_static (G_TYPE_OBJECT, "Board", &g_define_type_info, 0);
		g_once_init_leave (&board_type_id__volatile, board_type_id);
	}
	return board_type_id__volatile;
}

