/* games-controls-list.c generated by valac 0.43.92, the Vala compiler
 * generated from games-controls-list.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * games-controls.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Needed to force vala to include headers in the correct order.
 * See https://gitlab.gnome.org/GNOME/vala/issues/98
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <stdarg.h>

typedef enum  {
	COLUMNS_CONFKEY_COLUMN = 0,
	COLUMNS_LABEL_COLUMN,
	COLUMNS_KEYCODE_COLUMN,
	COLUMNS_KEYMODS_COLUMN,
	COLUMNS_DEFAULT_KEYCODE_COLUMN,
	COLUMNS_DEFAULT_KEYMODS_COLUMN,
	COLUMNS_N_COLUMNS
} Columns;

#define TYPE_COLUMNS (columns_get_type ())

#define TYPE_GAMES_CONTROLS_LIST (games_controls_list_get_type ())
#define GAMES_CONTROLS_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAMES_CONTROLS_LIST, GamesControlsList))
#define GAMES_CONTROLS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAMES_CONTROLS_LIST, GamesControlsListClass))
#define IS_GAMES_CONTROLS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAMES_CONTROLS_LIST))
#define IS_GAMES_CONTROLS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAMES_CONTROLS_LIST))
#define GAMES_CONTROLS_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAMES_CONTROLS_LIST, GamesControlsListClass))

typedef struct _GamesControlsList GamesControlsList;
typedef struct _GamesControlsListClass GamesControlsListClass;
typedef struct _GamesControlsListPrivate GamesControlsListPrivate;
enum  {
	GAMES_CONTROLS_LIST_0_PROPERTY,
	GAMES_CONTROLS_LIST_NUM_PROPERTIES
};
static GParamSpec* games_controls_list_properties[GAMES_CONTROLS_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GamesControlsList {
	GtkScrolledWindow parent_instance;
	GamesControlsListPrivate * priv;
};

struct _GamesControlsListClass {
	GtkScrolledWindowClass parent_class;
};

struct _GamesControlsListPrivate {
	GtkTreeModel* model;
	GtkListStore* store;
	GtkTreeView* view;
	GSettings* settings;
	gulong notify_handler_id;
};

static gint GamesControlsList_private_offset;
static gpointer games_controls_list_parent_class = NULL;

#define games_controls_gettext_package GETTEXT_PACKAGE
GType columns_get_type (void) G_GNUC_CONST;
GType games_controls_list_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesControlsList, g_object_unref)
GamesControlsList* games_controls_list_new (GSettings* settings);
GamesControlsList* games_controls_list_construct (GType object_type,
                                                  GSettings* settings);
static void games_controls_list_settings_changed_cb (GamesControlsList* self,
                                              const gchar* key);
static void _games_controls_list_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self);
static void games_controls_list_accel_edited_cb (GamesControlsList* self,
                                          const gchar* path_string,
                                          guint keyval,
                                          GdkModifierType mask,
                                          guint hardware_keycode);
static void _games_controls_list_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                                const gchar* path_string,
                                                                                guint accel_key,
                                                                                GdkModifierType accel_mods,
                                                                                guint hardware_keycode,
                                                                                gpointer self);
static void games_controls_list_accel_cleared_cb (GamesControlsList* self,
                                           const gchar* path_string);
static void _games_controls_list_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                                  const gchar* path_string,
                                                                                  gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void games_controls_list_add_control (GamesControlsList* self,
                                      const gchar* conf_key,
                                      const gchar* label,
                                      guint default_keyval);
void games_controls_list_add_controls (GamesControlsList* self,
                                       const gchar* first_gconf_key,
                                       ...);
static void games_controls_list_finalize (GObject * obj);

GType
columns_get_type (void)
{
	static volatile gsize columns_type_id__volatile = 0;
	if (g_once_init_enter (&columns_type_id__volatile)) {
		static const GEnumValue values[] = {{COLUMNS_CONFKEY_COLUMN, "COLUMNS_CONFKEY_COLUMN", "confkey-column"}, {COLUMNS_LABEL_COLUMN, "COLUMNS_LABEL_COLUMN", "label-column"}, {COLUMNS_KEYCODE_COLUMN, "COLUMNS_KEYCODE_COLUMN", "keycode-column"}, {COLUMNS_KEYMODS_COLUMN, "COLUMNS_KEYMODS_COLUMN", "keymods-column"}, {COLUMNS_DEFAULT_KEYCODE_COLUMN, "COLUMNS_DEFAULT_KEYCODE_COLUMN", "default-keycode-column"}, {COLUMNS_DEFAULT_KEYMODS_COLUMN, "COLUMNS_DEFAULT_KEYMODS_COLUMN", "default-keymods-column"}, {COLUMNS_N_COLUMNS, "COLUMNS_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
		GType columns_type_id;
		columns_type_id = g_enum_register_static ("Columns", values);
		g_once_init_leave (&columns_type_id__volatile, columns_type_id);
	}
	return columns_type_id__volatile;
}

static inline gpointer
games_controls_list_get_instance_private (GamesControlsList* self)
{
	return G_STRUCT_MEMBER_P (self, GamesControlsList_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/games-controls-list.vala"
	return self ? g_object_ref (self) : NULL;
#line 153 "games-controls-list.c"
}

static void
_games_controls_list_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self)
{
#line 55 "../src/games-controls-list.vala"
	games_controls_list_settings_changed_cb ((GamesControlsList*) self, key);
#line 163 "games-controls-list.c"
}

static void
_games_controls_list_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                           const gchar* path_string,
                                                                           guint accel_key,
                                                                           GdkModifierType accel_mods,
                                                                           guint hardware_keycode,
                                                                           gpointer self)
{
#line 83 "../src/games-controls-list.vala"
	games_controls_list_accel_edited_cb ((GamesControlsList*) self, path_string, accel_key, accel_mods, hardware_keycode);
#line 176 "games-controls-list.c"
}

static void
_games_controls_list_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                             const gchar* path_string,
                                                                             gpointer self)
{
#line 84 "../src/games-controls-list.vala"
	games_controls_list_accel_cleared_cb ((GamesControlsList*) self, path_string);
#line 186 "games-controls-list.c"
}

GamesControlsList*
games_controls_list_construct (GType object_type,
                               GSettings* settings)
{
	GamesControlsList * self = NULL;
	GtkCellRenderer* label_renderer = NULL;
	GtkCellRendererAccel* key_renderer = NULL;
	GtkTreeViewColumn* column = NULL;
	GSettings* _tmp0_;
	gulong _tmp1_;
	GtkListStore* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeView* _tmp6_;
	GtkTreeView* _tmp7_;
	GtkTreeView* _tmp8_;
	GtkCellRendererText* _tmp9_;
	GtkTreeViewColumn* _tmp10_;
	GtkTreeView* _tmp11_;
	GtkTreeViewColumn* _tmp12_;
	GtkCellRendererAccel* _tmp13_;
	GtkTreeViewColumn* _tmp14_;
	GtkTreeView* _tmp15_;
	GtkTreeViewColumn* _tmp16_;
	GtkTreeView* _tmp17_;
#line 46 "../src/games-controls-list.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 46 "../src/games-controls-list.vala"
	self = (GamesControlsList*) g_object_new (object_type, NULL);
#line 51 "../src/games-controls-list.vala"
	g_object_set ((GtkScrolledWindow*) self, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 52 "../src/games-controls-list.vala"
	g_object_set ((GtkScrolledWindow*) self, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 53 "../src/games-controls-list.vala"
	gtk_scrolled_window_set_shadow_type ((GtkScrolledWindow*) self, GTK_SHADOW_IN);
#line 54 "../src/games-controls-list.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 54 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->settings);
#line 54 "../src/games-controls-list.vala"
	self->priv->settings = _tmp0_;
#line 55 "../src/games-controls-list.vala"
	_tmp1_ = g_signal_connect_object (settings, "changed", (GCallback) _games_controls_list_settings_changed_cb_g_settings_changed, self, 0);
#line 55 "../src/games-controls-list.vala"
	self->priv->notify_handler_id = _tmp1_;
#line 58 "../src/games-controls-list.vala"
	_tmp2_ = gtk_list_store_new ((gint) COLUMNS_N_COLUMNS, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, -1);
#line 58 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->store);
#line 58 "../src/games-controls-list.vala"
	self->priv->store = _tmp2_;
#line 66 "../src/games-controls-list.vala"
	_tmp3_ = self->priv->store;
#line 66 "../src/games-controls-list.vala"
	_tmp4_ = _g_object_ref0 ((GtkTreeModel*) _tmp3_);
#line 66 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->model);
#line 66 "../src/games-controls-list.vala"
	self->priv->model = _tmp4_;
#line 67 "../src/games-controls-list.vala"
	_tmp5_ = self->priv->model;
#line 67 "../src/games-controls-list.vala"
	_tmp6_ = (GtkTreeView*) gtk_tree_view_new_with_model (_tmp5_);
#line 67 "../src/games-controls-list.vala"
	g_object_ref_sink (_tmp6_);
#line 67 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->view);
#line 67 "../src/games-controls-list.vala"
	self->priv->view = _tmp6_;
#line 69 "../src/games-controls-list.vala"
	_tmp7_ = self->priv->view;
#line 69 "../src/games-controls-list.vala"
	gtk_tree_view_set_headers_visible (_tmp7_, FALSE);
#line 70 "../src/games-controls-list.vala"
	_tmp8_ = self->priv->view;
#line 70 "../src/games-controls-list.vala"
	gtk_tree_view_set_enable_search (_tmp8_, FALSE);
#line 72 "../src/games-controls-list.vala"
	_tmp9_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 72 "../src/games-controls-list.vala"
	g_object_ref_sink (_tmp9_);
#line 72 "../src/games-controls-list.vala"
	_g_object_unref0 (label_renderer);
#line 72 "../src/games-controls-list.vala"
	label_renderer = (GtkCellRenderer*) _tmp9_;
#line 73 "../src/games-controls-list.vala"
	_tmp10_ = gtk_tree_view_column_new_with_attributes ("Control", label_renderer, "text", COLUMNS_LABEL_COLUMN, NULL);
#line 73 "../src/games-controls-list.vala"
	g_object_ref_sink (_tmp10_);
#line 73 "../src/games-controls-list.vala"
	_g_object_unref0 (column);
#line 73 "../src/games-controls-list.vala"
	column = _tmp10_;
#line 76 "../src/games-controls-list.vala"
	_tmp11_ = self->priv->view;
#line 76 "../src/games-controls-list.vala"
	_tmp12_ = column;
#line 76 "../src/games-controls-list.vala"
	gtk_tree_view_append_column (_tmp11_, _tmp12_);
#line 78 "../src/games-controls-list.vala"
	_tmp13_ = (GtkCellRendererAccel*) gtk_cell_renderer_accel_new ();
#line 78 "../src/games-controls-list.vala"
	g_object_ref_sink (_tmp13_);
#line 78 "../src/games-controls-list.vala"
	_g_object_unref0 (key_renderer);
#line 78 "../src/games-controls-list.vala"
	key_renderer = _tmp13_;
#line 80 "../src/games-controls-list.vala"
	g_object_set ((GtkCellRendererText*) key_renderer, "editable", TRUE, NULL);
#line 81 "../src/games-controls-list.vala"
	g_object_set (key_renderer, "accel-mode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER, NULL);
#line 83 "../src/games-controls-list.vala"
	g_signal_connect_object (key_renderer, "accel-edited", (GCallback) _games_controls_list_accel_edited_cb_gtk_cell_renderer_accel_accel_edited, self, 0);
#line 84 "../src/games-controls-list.vala"
	g_signal_connect_object (key_renderer, "accel-cleared", (GCallback) _games_controls_list_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared, self, 0);
#line 86 "../src/games-controls-list.vala"
	_tmp14_ = gtk_tree_view_column_new_with_attributes ("Key", (GtkCellRenderer*) key_renderer, "accel-key", COLUMNS_KEYCODE_COLUMN, "accel-mods", COLUMNS_KEYMODS_COLUMN, NULL);
#line 86 "../src/games-controls-list.vala"
	g_object_ref_sink (_tmp14_);
#line 86 "../src/games-controls-list.vala"
	_g_object_unref0 (column);
#line 86 "../src/games-controls-list.vala"
	column = _tmp14_;
#line 90 "../src/games-controls-list.vala"
	_tmp15_ = self->priv->view;
#line 90 "../src/games-controls-list.vala"
	_tmp16_ = column;
#line 90 "../src/games-controls-list.vala"
	gtk_tree_view_append_column (_tmp15_, _tmp16_);
#line 91 "../src/games-controls-list.vala"
	_tmp17_ = self->priv->view;
#line 91 "../src/games-controls-list.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp17_);
#line 46 "../src/games-controls-list.vala"
	_g_object_unref0 (column);
#line 46 "../src/games-controls-list.vala"
	_g_object_unref0 (key_renderer);
#line 46 "../src/games-controls-list.vala"
	_g_object_unref0 (label_renderer);
#line 46 "../src/games-controls-list.vala"
	return self;
#line 331 "games-controls-list.c"
}

GamesControlsList*
games_controls_list_new (GSettings* settings)
{
#line 46 "../src/games-controls-list.vala"
	return games_controls_list_construct (TYPE_GAMES_CONTROLS_LIST, settings);
#line 339 "games-controls-list.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 100 "../src/games-controls-list.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 347 "games-controls-list.c"
}

static void
games_controls_list_accel_cleared_cb (GamesControlsList* self,
                                      const gchar* path_string)
{
	GtkTreePath* path = NULL;
	GtkTreeIter iter = {0};
	gchar* conf_key = NULL;
	gint default_keyval = 0;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GSettings* _tmp10_;
	const gchar* _tmp11_;
#line 94 "../src/games-controls-list.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/games-controls-list.vala"
	g_return_if_fail (path_string != NULL);
#line 97 "../src/games-controls-list.vala"
	conf_key = NULL;
#line 98 "../src/games-controls-list.vala"
	default_keyval = 0;
#line 100 "../src/games-controls-list.vala"
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
#line 100 "../src/games-controls-list.vala"
	__vala_GtkTreePath_free0 (path);
#line 100 "../src/games-controls-list.vala"
	path = _tmp0_;
#line 101 "../src/games-controls-list.vala"
	_tmp1_ = path;
#line 101 "../src/games-controls-list.vala"
	if (_tmp1_ == NULL) {
#line 102 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 102 "../src/games-controls-list.vala"
		__vala_GtkTreePath_free0 (path);
#line 102 "../src/games-controls-list.vala"
		return;
#line 394 "games-controls-list.c"
	}
#line 104 "../src/games-controls-list.vala"
	_tmp2_ = self->priv->model;
#line 104 "../src/games-controls-list.vala"
	_tmp3_ = path;
#line 104 "../src/games-controls-list.vala"
	_tmp5_ = gtk_tree_model_get_iter (_tmp2_, &_tmp4_, _tmp3_);
#line 104 "../src/games-controls-list.vala"
	iter = _tmp4_;
#line 104 "../src/games-controls-list.vala"
	if (!_tmp5_) {
#line 105 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 105 "../src/games-controls-list.vala"
		__vala_GtkTreePath_free0 (path);
#line 105 "../src/games-controls-list.vala"
		return;
#line 412 "games-controls-list.c"
	}
#line 108 "../src/games-controls-list.vala"
	_tmp6_ = self->priv->model;
#line 108 "../src/games-controls-list.vala"
	_tmp7_ = iter;
#line 108 "../src/games-controls-list.vala"
	_tmp8_ = conf_key;
#line 108 "../src/games-controls-list.vala"
	gtk_tree_model_get (_tmp6_, &_tmp7_, COLUMNS_CONFKEY_COLUMN, _tmp8_, COLUMNS_DEFAULT_KEYCODE_COLUMN, default_keyval, -1);
#line 112 "../src/games-controls-list.vala"
	_tmp9_ = conf_key;
#line 112 "../src/games-controls-list.vala"
	if (_tmp9_ == NULL) {
#line 113 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 113 "../src/games-controls-list.vala"
		__vala_GtkTreePath_free0 (path);
#line 113 "../src/games-controls-list.vala"
		return;
#line 432 "games-controls-list.c"
	}
#line 117 "../src/games-controls-list.vala"
	_tmp10_ = self->priv->settings;
#line 117 "../src/games-controls-list.vala"
	_tmp11_ = conf_key;
#line 117 "../src/games-controls-list.vala"
	g_settings_set_int (_tmp10_, _tmp11_, default_keyval);
#line 94 "../src/games-controls-list.vala"
	_g_free0 (conf_key);
#line 94 "../src/games-controls-list.vala"
	__vala_GtkTreePath_free0 (path);
#line 444 "games-controls-list.c"
}

static void
games_controls_list_accel_edited_cb (GamesControlsList* self,
                                     const gchar* path_string,
                                     guint keyval,
                                     GdkModifierType mask,
                                     guint hardware_keycode)
{
	GtkTreePath* path = NULL;
	GtkTreeIter iter = {0};
	gchar* conf_key = NULL;
	gboolean valid = FALSE;
	gboolean unused_key = FALSE;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkTreeModel* _tmp10_;
	GtkTreeIter _tmp11_ = {0};
	gboolean _tmp12_;
#line 120 "../src/games-controls-list.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/games-controls-list.vala"
	g_return_if_fail (path_string != NULL);
#line 123 "../src/games-controls-list.vala"
	conf_key = NULL;
#line 125 "../src/games-controls-list.vala"
	unused_key = TRUE;
#line 127 "../src/games-controls-list.vala"
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
#line 127 "../src/games-controls-list.vala"
	__vala_GtkTreePath_free0 (path);
#line 127 "../src/games-controls-list.vala"
	path = _tmp0_;
#line 128 "../src/games-controls-list.vala"
	_tmp1_ = path;
#line 128 "../src/games-controls-list.vala"
	if (_tmp1_ == NULL) {
#line 129 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 129 "../src/games-controls-list.vala"
		__vala_GtkTreePath_free0 (path);
#line 129 "../src/games-controls-list.vala"
		return;
#line 496 "games-controls-list.c"
	}
#line 131 "../src/games-controls-list.vala"
	_tmp2_ = self->priv->model;
#line 131 "../src/games-controls-list.vala"
	_tmp3_ = path;
#line 131 "../src/games-controls-list.vala"
	_tmp5_ = gtk_tree_model_get_iter (_tmp2_, &_tmp4_, _tmp3_);
#line 131 "../src/games-controls-list.vala"
	iter = _tmp4_;
#line 131 "../src/games-controls-list.vala"
	if (!_tmp5_) {
#line 132 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 132 "../src/games-controls-list.vala"
		__vala_GtkTreePath_free0 (path);
#line 132 "../src/games-controls-list.vala"
		return;
#line 514 "games-controls-list.c"
	}
#line 135 "../src/games-controls-list.vala"
	_tmp6_ = self->priv->model;
#line 135 "../src/games-controls-list.vala"
	_tmp7_ = iter;
#line 135 "../src/games-controls-list.vala"
	_tmp8_ = conf_key;
#line 135 "../src/games-controls-list.vala"
	gtk_tree_model_get (_tmp6_, &_tmp7_, COLUMNS_CONFKEY_COLUMN, _tmp8_, -1);
#line 136 "../src/games-controls-list.vala"
	_tmp9_ = conf_key;
#line 136 "../src/games-controls-list.vala"
	if (_tmp9_ == NULL) {
#line 137 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 137 "../src/games-controls-list.vala"
		__vala_GtkTreePath_free0 (path);
#line 137 "../src/games-controls-list.vala"
		return;
#line 534 "games-controls-list.c"
	}
#line 139 "../src/games-controls-list.vala"
	_tmp10_ = self->priv->model;
#line 139 "../src/games-controls-list.vala"
	_tmp12_ = gtk_tree_model_get_iter_first (_tmp10_, &_tmp11_);
#line 139 "../src/games-controls-list.vala"
	iter = _tmp11_;
#line 139 "../src/games-controls-list.vala"
	valid = _tmp12_;
#line 140 "../src/games-controls-list.vala"
	while (TRUE) {
#line 546 "games-controls-list.c"
		gchar* actual_conf_key = NULL;
		GtkTreeModel* _tmp13_;
		GtkTreeIter _tmp14_;
		const gchar* _tmp15_;
		GSettings* _tmp16_;
		const gchar* _tmp17_;
		GtkListStore* _tmp22_;
		gboolean _tmp23_;
#line 140 "../src/games-controls-list.vala"
		if (!valid) {
#line 140 "../src/games-controls-list.vala"
			break;
#line 559 "games-controls-list.c"
		}
#line 141 "../src/games-controls-list.vala"
		actual_conf_key = NULL;
#line 143 "../src/games-controls-list.vala"
		_tmp13_ = self->priv->model;
#line 143 "../src/games-controls-list.vala"
		_tmp14_ = iter;
#line 143 "../src/games-controls-list.vala"
		_tmp15_ = actual_conf_key;
#line 143 "../src/games-controls-list.vala"
		gtk_tree_model_get (_tmp13_, &_tmp14_, COLUMNS_CONFKEY_COLUMN, _tmp15_, -1);
#line 145 "../src/games-controls-list.vala"
		_tmp16_ = self->priv->settings;
#line 145 "../src/games-controls-list.vala"
		_tmp17_ = actual_conf_key;
#line 145 "../src/games-controls-list.vala"
		if (((guint) g_settings_get_int (_tmp16_, _tmp17_)) == keyval) {
#line 577 "games-controls-list.c"
			const gchar* _tmp18_;
			const gchar* _tmp19_;
#line 146 "../src/games-controls-list.vala"
			unused_key = FALSE;
#line 148 "../src/games-controls-list.vala"
			_tmp18_ = conf_key;
#line 148 "../src/games-controls-list.vala"
			_tmp19_ = actual_conf_key;
#line 148 "../src/games-controls-list.vala"
			if (g_strcmp0 (_tmp18_, _tmp19_) == 0) {
#line 588 "games-controls-list.c"
				GtkMessageDialog* dialog = NULL;
				GtkMessageDialog* _tmp20_;
				GtkMessageDialog* _tmp21_;
#line 149 "../src/games-controls-list.vala"
				_tmp20_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "<span weight=\"bold\" size=\"larger\">%s</span>", _ ("This key is already in use."));
#line 149 "../src/games-controls-list.vala"
				g_object_ref_sink (_tmp20_);
#line 149 "../src/games-controls-list.vala"
				dialog = _tmp20_;
#line 156 "../src/games-controls-list.vala"
				_tmp21_ = dialog;
#line 156 "../src/games-controls-list.vala"
				gtk_dialog_run ((GtkDialog*) _tmp21_);
#line 148 "../src/games-controls-list.vala"
				_g_object_unref0 (dialog);
#line 604 "games-controls-list.c"
			}
#line 158 "../src/games-controls-list.vala"
			_g_free0 (actual_conf_key);
#line 158 "../src/games-controls-list.vala"
			break;
#line 610 "games-controls-list.c"
		}
#line 161 "../src/games-controls-list.vala"
		_tmp22_ = self->priv->store;
#line 161 "../src/games-controls-list.vala"
		_tmp23_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp22_, &iter);
#line 161 "../src/games-controls-list.vala"
		valid = _tmp23_;
#line 140 "../src/games-controls-list.vala"
		_g_free0 (actual_conf_key);
#line 620 "games-controls-list.c"
	}
#line 166 "../src/games-controls-list.vala"
	if (unused_key) {
#line 624 "games-controls-list.c"
		GSettings* _tmp24_;
		const gchar* _tmp25_;
#line 167 "../src/games-controls-list.vala"
		_tmp24_ = self->priv->settings;
#line 167 "../src/games-controls-list.vala"
		_tmp25_ = conf_key;
#line 167 "../src/games-controls-list.vala"
		g_settings_set_int (_tmp24_, _tmp25_, (gint) keyval);
#line 633 "games-controls-list.c"
	}
#line 120 "../src/games-controls-list.vala"
	_g_free0 (conf_key);
#line 120 "../src/games-controls-list.vala"
	__vala_GtkTreePath_free0 (path);
#line 639 "games-controls-list.c"
}

static void
games_controls_list_add_control (GamesControlsList* self,
                                 const gchar* conf_key,
                                 const gchar* label,
                                 guint default_keyval)
{
	GtkTreeIter iter = {0};
	guint keyval = 0U;
	GSettings* _tmp0_;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
#line 170 "../src/games-controls-list.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/games-controls-list.vala"
	g_return_if_fail (conf_key != NULL);
#line 174 "../src/games-controls-list.vala"
	if (label == NULL) {
#line 175 "../src/games-controls-list.vala"
		label = _ ("Unknown Command");
#line 661 "games-controls-list.c"
	}
#line 177 "../src/games-controls-list.vala"
	_tmp0_ = self->priv->settings;
#line 177 "../src/games-controls-list.vala"
	keyval = (guint) g_settings_get_int (_tmp0_, conf_key);
#line 179 "../src/games-controls-list.vala"
	_tmp1_ = self->priv->store;
#line 179 "../src/games-controls-list.vala"
	gtk_list_store_insert_with_values (_tmp1_, &_tmp2_, -1, COLUMNS_CONFKEY_COLUMN, conf_key, COLUMNS_LABEL_COLUMN, label, COLUMNS_KEYCODE_COLUMN, keyval, COLUMNS_KEYMODS_COLUMN, 0, COLUMNS_DEFAULT_KEYCODE_COLUMN, default_keyval, COLUMNS_DEFAULT_KEYMODS_COLUMN, 0, -1);
#line 179 "../src/games-controls-list.vala"
	iter = _tmp2_;
#line 673 "games-controls-list.c"
}

void
games_controls_list_add_controls (GamesControlsList* self,
                                  const gchar* first_gconf_key,
                                  ...)
{
	va_list args = {0};
	gchar* key = NULL;
	gchar* label = NULL;
	guint keyval = 0U;
	gchar* _tmp0_;
#line 189 "../src/games-controls-list.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/games-controls-list.vala"
	g_return_if_fail (first_gconf_key != NULL);
#line 190 "../src/games-controls-list.vala"
	va_start (args, first_gconf_key);
#line 195 "../src/games-controls-list.vala"
	_tmp0_ = g_strdup (first_gconf_key);
#line 195 "../src/games-controls-list.vala"
	_g_free0 (key);
#line 195 "../src/games-controls-list.vala"
	key = _tmp0_;
#line 196 "../src/games-controls-list.vala"
	while (TRUE) {
#line 700 "games-controls-list.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 196 "../src/games-controls-list.vala"
		_tmp1_ = key;
#line 196 "../src/games-controls-list.vala"
		if (!(_tmp1_ != NULL)) {
#line 196 "../src/games-controls-list.vala"
			break;
#line 714 "games-controls-list.c"
		}
#line 197 "../src/games-controls-list.vala"
		_tmp2_ = va_arg (args, gchar*);
#line 197 "../src/games-controls-list.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 197 "../src/games-controls-list.vala"
		_g_free0 (label);
#line 197 "../src/games-controls-list.vala"
		label = _tmp3_;
#line 198 "../src/games-controls-list.vala"
		keyval = va_arg (args, guint);
#line 199 "../src/games-controls-list.vala"
		_tmp4_ = key;
#line 199 "../src/games-controls-list.vala"
		_tmp5_ = label;
#line 199 "../src/games-controls-list.vala"
		games_controls_list_add_control (self, _tmp4_, _tmp5_, keyval);
#line 200 "../src/games-controls-list.vala"
		_tmp6_ = va_arg (args, gchar*);
#line 200 "../src/games-controls-list.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 200 "../src/games-controls-list.vala"
		_g_free0 (key);
#line 200 "../src/games-controls-list.vala"
		key = _tmp7_;
#line 740 "games-controls-list.c"
	}
#line 189 "../src/games-controls-list.vala"
	_g_free0 (label);
#line 189 "../src/games-controls-list.vala"
	_g_free0 (key);
#line 189 "../src/games-controls-list.vala"
	va_end (args);
#line 748 "games-controls-list.c"
}

static void
games_controls_list_settings_changed_cb (GamesControlsList* self,
                                         const gchar* key)
{
	GtkTreeIter iter = {0};
	gboolean valid = FALSE;
	GtkTreeModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 204 "../src/games-controls-list.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/games-controls-list.vala"
	g_return_if_fail (key != NULL);
#line 209 "../src/games-controls-list.vala"
	_tmp0_ = self->priv->model;
#line 209 "../src/games-controls-list.vala"
	_tmp2_ = gtk_tree_model_get_iter_first (_tmp0_, &_tmp1_);
#line 209 "../src/games-controls-list.vala"
	iter = _tmp1_;
#line 209 "../src/games-controls-list.vala"
	valid = _tmp2_;
#line 210 "../src/games-controls-list.vala"
	while (TRUE) {
#line 774 "games-controls-list.c"
		gchar* conf_key = NULL;
		GtkTreeModel* _tmp3_;
		GtkTreeIter _tmp4_;
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		GtkListStore* _tmp13_;
		gboolean _tmp14_;
#line 210 "../src/games-controls-list.vala"
		if (!valid) {
#line 210 "../src/games-controls-list.vala"
			break;
#line 786 "games-controls-list.c"
		}
#line 213 "../src/games-controls-list.vala"
		_tmp3_ = self->priv->model;
#line 213 "../src/games-controls-list.vala"
		_tmp4_ = iter;
#line 213 "../src/games-controls-list.vala"
		gtk_tree_model_get (_tmp3_, &_tmp4_, COLUMNS_CONFKEY_COLUMN, &_tmp5_, -1);
#line 213 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 213 "../src/games-controls-list.vala"
		conf_key = _tmp5_;
#line 215 "../src/games-controls-list.vala"
		_tmp6_ = conf_key;
#line 215 "../src/games-controls-list.vala"
		if (g_strcmp0 (key, _tmp6_) == 0) {
#line 802 "games-controls-list.c"
			guint keyval = 0U;
			guint default_keyval = 0U;
			GtkTreeModel* _tmp7_;
			GtkTreeIter _tmp8_;
			guint _tmp9_ = 0U;
			GSettings* _tmp10_;
			GtkListStore* _tmp11_;
			GtkTreeIter _tmp12_;
#line 218 "../src/games-controls-list.vala"
			_tmp7_ = self->priv->model;
#line 218 "../src/games-controls-list.vala"
			_tmp8_ = iter;
#line 218 "../src/games-controls-list.vala"
			gtk_tree_model_get (_tmp7_, &_tmp8_, COLUMNS_DEFAULT_KEYCODE_COLUMN, &_tmp9_, -1);
#line 218 "../src/games-controls-list.vala"
			default_keyval = _tmp9_;
#line 220 "../src/games-controls-list.vala"
			_tmp10_ = self->priv->settings;
#line 220 "../src/games-controls-list.vala"
			keyval = (guint) g_settings_get_int (_tmp10_, key);
#line 222 "../src/games-controls-list.vala"
			_tmp11_ = self->priv->store;
#line 222 "../src/games-controls-list.vala"
			_tmp12_ = iter;
#line 222 "../src/games-controls-list.vala"
			gtk_list_store_set (_tmp11_, &_tmp12_, COLUMNS_KEYCODE_COLUMN, keyval, COLUMNS_KEYMODS_COLUMN, 0, -1);
#line 226 "../src/games-controls-list.vala"
			_g_free0 (conf_key);
#line 226 "../src/games-controls-list.vala"
			break;
#line 833 "games-controls-list.c"
		}
#line 229 "../src/games-controls-list.vala"
		_tmp13_ = self->priv->store;
#line 229 "../src/games-controls-list.vala"
		_tmp14_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp13_, &iter);
#line 229 "../src/games-controls-list.vala"
		valid = _tmp14_;
#line 210 "../src/games-controls-list.vala"
		_g_free0 (conf_key);
#line 843 "games-controls-list.c"
	}
}

static void
games_controls_list_class_init (GamesControlsListClass * klass,
                                gpointer klass_data)
{
#line 38 "../src/games-controls-list.vala"
	games_controls_list_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/games-controls-list.vala"
	g_type_class_adjust_private_offset (klass, &GamesControlsList_private_offset);
#line 38 "../src/games-controls-list.vala"
	G_OBJECT_CLASS (klass)->finalize = games_controls_list_finalize;
#line 857 "games-controls-list.c"
}

static void
games_controls_list_instance_init (GamesControlsList * self,
                                   gpointer klass)
{
#line 38 "../src/games-controls-list.vala"
	self->priv = games_controls_list_get_instance_private (self);
#line 866 "games-controls-list.c"
}

static void
games_controls_list_finalize (GObject * obj)
{
	GamesControlsList * self;
#line 38 "../src/games-controls-list.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAMES_CONTROLS_LIST, GamesControlsList);
#line 39 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->model);
#line 40 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->store);
#line 41 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->view);
#line 43 "../src/games-controls-list.vala"
	_g_object_unref0 (self->priv->settings);
#line 38 "../src/games-controls-list.vala"
	G_OBJECT_CLASS (games_controls_list_parent_class)->finalize (obj);
#line 885 "games-controls-list.c"
}

GType
games_controls_list_get_type (void)
{
	static volatile gsize games_controls_list_type_id__volatile = 0;
	if (g_once_init_enter (&games_controls_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GamesControlsListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_controls_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesControlsList), 0, (GInstanceInitFunc) games_controls_list_instance_init, NULL };
		GType games_controls_list_type_id;
		games_controls_list_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "GamesControlsList", &g_define_type_info, 0);
		GamesControlsList_private_offset = g_type_add_instance_private (games_controls_list_type_id, sizeof (GamesControlsListPrivate));
		g_once_init_leave (&games_controls_list_type_id__volatile, games_controls_list_type_id);
	}
	return games_controls_list_type_id__volatile;
}

