/* theme.c generated by valac 0.43.92, the Vala compiler
 * generated from theme.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * theme.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define TYPE_THEME (theme_get_type ())
typedef struct _Theme Theme;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	PLAYER_ID_PLAYER1 = 0,
	PLAYER_ID_PLAYER2,
	PLAYER_ID_NOBODY
} PlayerID;

#define TYPE_PLAYER_ID (player_id_get_type ())

#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;

struct _Theme {
	gchar* title;
	gchar* fname_tileset;
	gchar* fname_bground;
	gchar* grid_color;
	gchar* player1;
	gchar* player2;
	gchar* player1_win;
	gchar* player2_win;
	gchar* player1_turn;
	gchar* player2_turn;
};

GType theme_get_type (void) G_GNUC_CONST;
Theme* theme_dup (const Theme* self);
void theme_free (Theme* self);
void theme_copy (const Theme* self,
                 Theme* dest);
void theme_destroy (Theme* self);
#define theme_gettext_package GETTEXT_PACKAGE
gchar* theme_get_title (gint id);
GType player_id_get_type (void) G_GNUC_CONST;
gchar* theme_get_player_turn (PlayerID who);
GType prefs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Prefs, g_object_unref)
Prefs* prefs_get_instance (void);
gint prefs_get_theme_id (Prefs* self);
gchar* theme_get_player_win (PlayerID who);
gchar* theme_get_player (PlayerID who);

const Theme theme[5] = {{N_ ("High Contrast"), "tileset_50x50_hcontrast.svg", NULL, "#000000", N_ ("Circle"), N_ ("Cross"), N_ ("Circle wins!"), N_ ("Cross wins!"), N_ ("Circle’s turn"), N_ ("Cross’s turn")}, {N_ ("High Contrast Inverse"), "tileset_50x50_hcinverse.svg", NULL, "#FFFFFF", N_ ("Circle"), N_ ("Cross"), N_ ("Circle wins!"), N_ ("Cross wins!"), N_ ("Circle’s turn"), N_ ("Cross’s turn")}, {N_ ("Red and Green Marbles"), "tileset_50x50_faenza-glines-icon1.svg", "bg_toplight.png", "#727F8C", N_ ("Red"), N_ ("Green"), N_ ("Red wins!"), N_ ("Green wins!"), N_ ("Red’s turn"), N_ ("Green’s turn")}, {N_ ("Blue and Red Marbles"), "tileset_50x50_faenza-glines-icon2.svg", "bg_toplight.png", "#727F8C", N_ ("Blue"), N_ ("Red"), N_ ("Blue wins!"), N_ ("Red wins!"), N_ ("Blue’s turn"), N_ ("Red’s turn")}, {N_ ("Stars and Rings"), "tileset_50x50_faenza-gnect-icon.svg", "bg_toplight.png", "#727F8C", N_ ("Red"), N_ ("Green"), N_ ("Red wins!"), N_ ("Green wins!"), N_ ("Red’s turn"), N_ ("Green’s turn")}};

void
theme_copy (const Theme* self,
            Theme* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
#line 22 "../src/theme.vala"
	_tmp0_ = (*self).title;
#line 22 "../src/theme.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).title);
#line 22 "../src/theme.vala"
	(*dest).title = _tmp1_;
#line 22 "../src/theme.vala"
	_tmp2_ = (*self).fname_tileset;
#line 22 "../src/theme.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).fname_tileset);
#line 22 "../src/theme.vala"
	(*dest).fname_tileset = _tmp3_;
#line 22 "../src/theme.vala"
	_tmp4_ = (*self).fname_bground;
#line 22 "../src/theme.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).fname_bground);
#line 22 "../src/theme.vala"
	(*dest).fname_bground = _tmp5_;
#line 22 "../src/theme.vala"
	_tmp6_ = (*self).grid_color;
#line 22 "../src/theme.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).grid_color);
#line 22 "../src/theme.vala"
	(*dest).grid_color = _tmp7_;
#line 22 "../src/theme.vala"
	_tmp8_ = (*self).player1;
#line 22 "../src/theme.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).player1);
#line 22 "../src/theme.vala"
	(*dest).player1 = _tmp9_;
#line 22 "../src/theme.vala"
	_tmp10_ = (*self).player2;
#line 22 "../src/theme.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).player2);
#line 22 "../src/theme.vala"
	(*dest).player2 = _tmp11_;
#line 22 "../src/theme.vala"
	_tmp12_ = (*self).player1_win;
#line 22 "../src/theme.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).player1_win);
#line 22 "../src/theme.vala"
	(*dest).player1_win = _tmp13_;
#line 22 "../src/theme.vala"
	_tmp14_ = (*self).player2_win;
#line 22 "../src/theme.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).player2_win);
#line 22 "../src/theme.vala"
	(*dest).player2_win = _tmp15_;
#line 22 "../src/theme.vala"
	_tmp16_ = (*self).player1_turn;
#line 22 "../src/theme.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).player1_turn);
#line 22 "../src/theme.vala"
	(*dest).player1_turn = _tmp17_;
#line 22 "../src/theme.vala"
	_tmp18_ = (*self).player2_turn;
#line 22 "../src/theme.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 22 "../src/theme.vala"
	_g_free0 ((*dest).player2_turn);
#line 22 "../src/theme.vala"
	(*dest).player2_turn = _tmp19_;
#line 189 "theme.c"
}

void
theme_destroy (Theme* self)
{
#line 23 "../src/theme.vala"
	_g_free0 ((*self).title);
#line 24 "../src/theme.vala"
	_g_free0 ((*self).fname_tileset);
#line 25 "../src/theme.vala"
	_g_free0 ((*self).fname_bground);
#line 26 "../src/theme.vala"
	_g_free0 ((*self).grid_color);
#line 27 "../src/theme.vala"
	_g_free0 ((*self).player1);
#line 28 "../src/theme.vala"
	_g_free0 ((*self).player2);
#line 29 "../src/theme.vala"
	_g_free0 ((*self).player1_win);
#line 30 "../src/theme.vala"
	_g_free0 ((*self).player2_win);
#line 31 "../src/theme.vala"
	_g_free0 ((*self).player1_turn);
#line 32 "../src/theme.vala"
	_g_free0 ((*self).player2_turn);
#line 215 "theme.c"
}

Theme*
theme_dup (const Theme* self)
{
	Theme* dup;
#line 22 "../src/theme.vala"
	dup = g_new0 (Theme, 1);
#line 22 "../src/theme.vala"
	theme_copy (self, dup);
#line 22 "../src/theme.vala"
	return dup;
#line 228 "theme.c"
}

void
theme_free (Theme* self)
{
#line 22 "../src/theme.vala"
	theme_destroy (self);
#line 22 "../src/theme.vala"
	g_free (self);
#line 238 "theme.c"
}

GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_id__volatile)) {
		GType theme_type_id;
		theme_type_id = g_boxed_type_register_static ("Theme", (GBoxedCopyFunc) theme_dup, (GBoxedFreeFunc) theme_free);
		g_once_init_leave (&theme_type_id__volatile, theme_type_id);
	}
	return theme_type_id__volatile;
}

gchar*
theme_get_title (gint id)
{
	gchar* result = NULL;
	Theme _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 42 "../src/theme.vala"
	_tmp0_ = theme[id];
#line 42 "../src/theme.vala"
	_tmp1_ = _tmp0_.title;
#line 42 "../src/theme.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 42 "../src/theme.vala"
	result = _tmp2_;
#line 42 "../src/theme.vala"
	return result;
#line 270 "theme.c"
}

gchar*
theme_get_player_turn (PlayerID who)
{
	gchar* result = NULL;
	Prefs* _tmp7_;
	Prefs* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Theme _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
#line 46 "../src/theme.vala"
	if (who == PLAYER_ID_PLAYER1) {
#line 286 "theme.c"
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 47 "../src/theme.vala"
		_tmp0_ = prefs_get_instance ();
#line 47 "../src/theme.vala"
		_tmp1_ = _tmp0_;
#line 47 "../src/theme.vala"
		_tmp2_ = prefs_get_theme_id (_tmp1_);
#line 47 "../src/theme.vala"
		_tmp3_ = _tmp2_;
#line 47 "../src/theme.vala"
		_tmp4_ = theme[_tmp3_];
#line 47 "../src/theme.vala"
		_tmp5_ = _tmp4_.player1_turn;
#line 47 "../src/theme.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 47 "../src/theme.vala"
		result = _tmp6_;
#line 47 "../src/theme.vala"
		return result;
#line 312 "theme.c"
	}
#line 48 "../src/theme.vala"
	_tmp7_ = prefs_get_instance ();
#line 48 "../src/theme.vala"
	_tmp8_ = _tmp7_;
#line 48 "../src/theme.vala"
	_tmp9_ = prefs_get_theme_id (_tmp8_);
#line 48 "../src/theme.vala"
	_tmp10_ = _tmp9_;
#line 48 "../src/theme.vala"
	_tmp11_ = theme[_tmp10_];
#line 48 "../src/theme.vala"
	_tmp12_ = _tmp11_.player2_turn;
#line 48 "../src/theme.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 48 "../src/theme.vala"
	result = _tmp13_;
#line 48 "../src/theme.vala"
	return result;
#line 332 "theme.c"
}

gchar*
theme_get_player_win (PlayerID who)
{
	gchar* result = NULL;
	Prefs* _tmp7_;
	Prefs* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Theme _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
#line 52 "../src/theme.vala"
	if (who == PLAYER_ID_PLAYER1) {
#line 348 "theme.c"
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 53 "../src/theme.vala"
		_tmp0_ = prefs_get_instance ();
#line 53 "../src/theme.vala"
		_tmp1_ = _tmp0_;
#line 53 "../src/theme.vala"
		_tmp2_ = prefs_get_theme_id (_tmp1_);
#line 53 "../src/theme.vala"
		_tmp3_ = _tmp2_;
#line 53 "../src/theme.vala"
		_tmp4_ = theme[_tmp3_];
#line 53 "../src/theme.vala"
		_tmp5_ = _tmp4_.player1_win;
#line 53 "../src/theme.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 53 "../src/theme.vala"
		result = _tmp6_;
#line 53 "../src/theme.vala"
		return result;
#line 374 "theme.c"
	}
#line 54 "../src/theme.vala"
	_tmp7_ = prefs_get_instance ();
#line 54 "../src/theme.vala"
	_tmp8_ = _tmp7_;
#line 54 "../src/theme.vala"
	_tmp9_ = prefs_get_theme_id (_tmp8_);
#line 54 "../src/theme.vala"
	_tmp10_ = _tmp9_;
#line 54 "../src/theme.vala"
	_tmp11_ = theme[_tmp10_];
#line 54 "../src/theme.vala"
	_tmp12_ = _tmp11_.player2_win;
#line 54 "../src/theme.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 54 "../src/theme.vala"
	result = _tmp13_;
#line 54 "../src/theme.vala"
	return result;
#line 394 "theme.c"
}

gchar*
theme_get_player (PlayerID who)
{
	gchar* result = NULL;
	Prefs* _tmp7_;
	Prefs* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Theme _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
#line 58 "../src/theme.vala"
	if (who == PLAYER_ID_PLAYER1) {
#line 410 "theme.c"
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 59 "../src/theme.vala"
		_tmp0_ = prefs_get_instance ();
#line 59 "../src/theme.vala"
		_tmp1_ = _tmp0_;
#line 59 "../src/theme.vala"
		_tmp2_ = prefs_get_theme_id (_tmp1_);
#line 59 "../src/theme.vala"
		_tmp3_ = _tmp2_;
#line 59 "../src/theme.vala"
		_tmp4_ = theme[_tmp3_];
#line 59 "../src/theme.vala"
		_tmp5_ = _tmp4_.player1;
#line 59 "../src/theme.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 59 "../src/theme.vala"
		result = _tmp6_;
#line 59 "../src/theme.vala"
		return result;
#line 436 "theme.c"
	}
#line 60 "../src/theme.vala"
	_tmp7_ = prefs_get_instance ();
#line 60 "../src/theme.vala"
	_tmp8_ = _tmp7_;
#line 60 "../src/theme.vala"
	_tmp9_ = prefs_get_theme_id (_tmp8_);
#line 60 "../src/theme.vala"
	_tmp10_ = _tmp9_;
#line 60 "../src/theme.vala"
	_tmp11_ = theme[_tmp10_];
#line 60 "../src/theme.vala"
	_tmp12_ = _tmp11_.player2;
#line 60 "../src/theme.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 60 "../src/theme.vala"
	result = _tmp13_;
#line 60 "../src/theme.vala"
	return result;
#line 456 "theme.c"
}

